#include "BranchLoadWindow.h"
//extern DetailWindow* DetailWindow1;
//extern SimulationWindow* SimulationWindow1;
//extern BranchLoadEvolutionWindow* BranchLoadWindow1;
extern MainWindow* MainWindow1;

BranchLoadWindow::BranchLoadWindow(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE)
{
    //plBranchLoadGraph = new wxPanel(this, -1);
	Chart3 = new BranchChart(this, MainWindow1->Canvas1->GetContext(), BTCLOSEBE + 121, wxDefaultPosition, wxSize(320,240));
    lbBranch = new wxStaticText(this, -1, wxT("Branch: "));
    lbBranchNumber = new wxStaticText(this, -1, wxT("-"));
    lbHour = new wxStaticText(this, -1, wxT("Hour "));
    scHour = new wxSpinCtrl(this, SCHOUR, wxT("0"), wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 0, 23);
    lbLoad = new wxStaticText(this, -1, wxT("Load (MW): "));
    lbBranchLoad = new wxStaticText(this, -1, wxT("-"));
    btClose = new wxButton(this, BTCLOSEBE, wxT("Close"));

    set_properties();
    do_layout();
}


BEGIN_EVENT_TABLE(BranchLoadWindow, wxFrame)
    EVT_SPINCTRL(SCHOUR, BranchLoadWindow::OnHourSpin)
    EVT_BUTTON(BTCLOSEBE, BranchLoadWindow::OnCloseButton)
	EVT_CLOSE(BranchLoadWindow::OnClose)
END_EVENT_TABLE();


void BranchLoadWindow::OnClose(wxCloseEvent &event)
{
	event.Veto();
	Hide();
}

void BranchLoadWindow::OnCloseButton(wxCommandEvent &event)
{
	Hide();
}

void BranchLoadWindow::OnHourSpin(wxSpinEvent &event)
{
	Chart3->horario = event.GetPosition();
	Chart3->line = 1;
	Chart3->Refresh(false);
}

void BranchLoadWindow::set_properties()
{
    // begin wxGlade: BranchLoadWindow::set_properties
    SetTitle(wxT("VisciPower - Branch Load Evolution"));
    // end wxGlade
}


void BranchLoadWindow::do_layout()
{
    // begin wxGlade: BranchLoadWindow::do_layout

	wxFlexGridSizer* sizer_4 = new wxFlexGridSizer(2, 1, 2, 2);
    wxGridSizer* grid_sizer_2 = new wxGridSizer(2, 2, 2, 2);
    wxBoxSizer* SizerHour_1 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* SizerHour = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_5 = new wxBoxSizer(wxHORIZONTAL);
	
	sizer_4->AddGrowableCol(0, 0);
	sizer_4->AddGrowableRow(0, 0);
	
    sizer_4->Add(Chart3, 1, wxEXPAND, 0);
    sizer_5->Add(lbBranch, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_5->Add(lbBranchNumber, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    grid_sizer_2->Add(sizer_5, 1, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerHour->Add(lbHour, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerHour->Add(scHour, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    grid_sizer_2->Add(SizerHour, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerHour_1->Add(lbLoad, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerHour_1->Add(lbBranchLoad, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    grid_sizer_2->Add(SizerHour_1, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    grid_sizer_2->Add(btClose, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	sizer_4->Add(grid_sizer_2, 1, wxEXPAND, 0);
    SetAutoLayout(true);

    SetSizer(sizer_4);
    sizer_4->Fit(this);
    sizer_4->SetSizeHints(this);
	
    Layout();
    // end wxGlade
}

