#include <wx/wx.h>
#include <wx/image.h>

#ifndef BRANCHLOADWINDOW_H
#define BRANCHLOADWINDOW_H

#include <wx/spinctrl.h>

#include "MainWindow.h"
#include "DetailWindow.h"
#include "SimulationWindow.h"
#include "BranchChart.h"

class BranchChart;

class BranchLoadWindow: public wxFrame {
public:
    enum {
        SCHOUR = 1021,
        BTCLOSEBE = 1023
    };

    BranchLoadWindow(wxWindow* parent, int id, const wxString& title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_FRAME_STYLE);

	wxSpinCtrl* scHour;
	BranchChart* Chart3;
	wxStaticText* lbBranchNumber;
	wxStaticText* lbBranchLoad;
	
private:
    void set_properties();
    void do_layout();

protected:
    wxPanel* plBranchLoadGraph;
	wxStaticText* lbBranch;
	wxStaticText* lbLoad;
    wxStaticText* lbHour;
    wxButton* btClose;

    DECLARE_EVENT_TABLE();

public:
    void OnHourSpin(wxSpinEvent &event); 
    void OnCloseButton(wxCommandEvent &event);
	void OnClose(wxCloseEvent &event);
}; 


#endif // BRANCHLOADWINDOW_H
