#ifndef DEMANDCHART_H
#define DEMANDCHART_H

#include <wx/wx.h>
#include <wx/glcanvas.h>
#include "vpDefs.h"
#include "vpAux.h"
//#include "vpSim.h"

#include "MainWindow.h"
#include "DetailWindow.h"
#include "SimulationWindow.h"
#include "BranchLoadWindow.h"
#include "LoadChart.h"

class DemandChart: public wxGLCanvas {
//    friend class MyFrame;
public:
	DemandChart( wxWindow *parent, wxGLContext* other, wxWindowID id = wxID_ANY,
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = 0, const wxString& name = _T("DemandChart") );
    ~DemandChart();

    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    void OnEraseBackground(wxEraseEvent& event);
    void InitGL();
	void Zoom(int w=-1, int h=-1);
	void DrawChart();
	void DrawMouseLine(GLfloat x, GLfloat y);
	void OnMouseMotion(wxMouseEvent &event);
private:
	void OnClick(wxMouseEvent &event);
	void OnKeyDown(wxKeyEvent& event);
    bool m_init;
	GLfloat	shift1, step1;
	int info1;
	GLfloat m_xmin, m_xmax, m_ymin, m_ymax;	
	
	char *m_title, *m_xtitle, *m_ytitle, *m_time, *m_demand;
	float m_xtitlew, m_xtitleh,
	m_ytitlew, m_ytitleh,
	m_titlew, m_titleh,
	m_bw, m_bh;
	

DECLARE_EVENT_TABLE()
};

#endif //DEMANDCHART_H
