#include "DetailView.h"


extern DetailWindow* DetailWindow1;
extern BranchLoadWindow* BranchLoadWindow1;

extern GLuint Mapa;

BEGIN_EVENT_TABLE(DetailCanvas, wxGLCanvas)
	//EVT_TIMER(MOUSETIMER, DetailCanvas::OnMouseTimer)
	EVT_SIZE(DetailCanvas::OnSize)
    EVT_PAINT(DetailCanvas::OnPaint)
    EVT_ERASE_BACKGROUND(DetailCanvas::OnEraseBackground)
    EVT_ENTER_WINDOW(DetailCanvas::OnEnterWindow)
	EVT_LEFT_DCLICK(DetailCanvas::OnDoubleClick)
	EVT_LEFT_DOWN(DetailCanvas::OnClick)
	EVT_LEFT_UP(DetailCanvas::OnClick)		
	EVT_RIGHT_DOWN(DetailCanvas::OnClick)
	EVT_KEY_DOWN(DetailCanvas::OnKeyDown)
	EVT_MOTION(DetailCanvas::OnMouseMotion)
END_EVENT_TABLE()

extern int 		horario,
				timeframe,
				show_interval,
				selected_branch,
				current_circuit;

extern GLint branch_num;

extern BUS bus[BUS_NUM];
extern BRANCH branch[BRANCH_NUM];
extern GBUS Gbus[BUS_NUM];
extern GBRANCH Gbranch[BRANCH_NUM];
extern BRANCH_DSP branch_dsp[BRANCH_NUM];

extern GLfloat carregamento_overload;

DetailCanvas::DetailCanvas(wxWindow *parent, wxGLContext* other, wxWindowID id,
    const wxPoint& pos, const wxSize& size, long style, const wxString& name):
    
	wxGLCanvas(parent, other, id, pos, size, style|wxFULL_REPAINT_ON_RESIZE , name)
	//MouseTimer(this, MOUSETIMER) 
{
    m_init = false;

	info = 0;
	
	zf_min = 0.1;
	zf_max = 30.0; /* Zoom Factor Limits */
	zf_inc = 0.5; /* Zoom Factor Increment */
	zf = 2.0;
	max_coord[0] = 2444.0;
	//max_coord[0] = 3.0;
	max_coord[1] = 1764.0;
	//max_coord[1] = 3.0;
    center[0] = max_coord[0]/2.0;
    center[1] = max_coord[1]/2.0;

}

DetailCanvas::~DetailCanvas()
{
}

void DetailCanvas::Render()
{
    wxPaintDC dc(this);

    if (!GetContext()) return;

    SetCurrent();
    // Init OpenGL once, but after SetCurrent
    if (!m_init)
    {
        InitGL();

		glClearColor (bkg1[0], bkg1[1], bkg1[2], bkg1[3]);
	
		center[0] = max_coord[0] / 2.0;
		center[1] = max_coord[1] / 2.0;

        m_init = true;
		
		Zoom();		
    }

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	DrawDetail(GL_RENDER);
	
	//glRasterPos2i(0, 0);
	//glTranslatef(0, 0, 0.0);
	//font->Render("teste");
	
///    glFlush();
    SwapBuffers();
}

void DetailCanvas::OnEnterWindow( wxMouseEvent& WXUNUSED(event) )
{
    //SetFocus();
}

void DetailCanvas::OnPaint( wxPaintEvent& WXUNUSED(event) )
{
    Render();
}

void DetailCanvas::OnSize(wxSizeEvent& event)
{
    // this is also necessary to update the context on some platforms
    wxGLCanvas::OnSize(event);
	Zoom();
	//event.Skip();
}

void DetailCanvas::OnEraseBackground(wxEraseEvent& WXUNUSED(event))
{
  // Do nothing, to avoid flashing.
}

void DetailCanvas::InitGL()
{
//    SetCurrent();
}

void DetailCanvas::UpdateBranchColor(int branch_number)//Branch_Color
{
	int i;//, c1 = 0, c2 = 0;

	if (branch_number == selected_branch)
	{
		branch[branch_number].color[0] = 0.0;
		branch[branch_number].color[1] = 1.0;
		branch[branch_number].color[2] = 0.0;
	}
	else if (show_interval == 0)
	{
		for (i = 0; i < timeframe; i++)
		{
			if (branch_dsp[branch_number].pot_perc[i] >= carregamento_overload)
			{
				branch[branch_number].color[0] = 1.0;
				branch[branch_number].color[1] = 0.0;
				branch[branch_number].color[2] = 0.0;
				break;
			}
			else
			{
				branch[branch_number].color[0] = 0.0;
				branch[branch_number].color[1] = 0.0;
				branch[branch_number].color[2] = 1.0;
			}
		}
	}
	else
	{
		branch[branch_number].color[0] = branch_color[0];
		branch[branch_number].color[1] = branch_color[1];
		branch[branch_number].color[2] = branch_color[2];
	}

	glColor3fv(branch[branch_number].color);

}

void DetailCanvas::DrawDetail(GLenum mode)
{
	int i;
	GLfloat 	*detail_visible_coords;
	
	//detail_visible_coords = GetVisibleArea();
	
	/* Plot Branches */
	/*for (i = 0; i < branch_num; i++)
	{

		if ((branch_dsp[i].pot_perc[horario] > carregamento_overload)
		    && (branch[i].circuit > current_circuit)
		    && (show_interval == 1))
		{
			glColor3fv(problem_branch_color);

			DrawCircunference(15.0, Gbranch[i].center[0], Gbranch[i].center[1], 1);
		}

		//if (branch[i].circuit <= current_circuit)
		if 	((branch[i].circuit <= current_circuit)
		    /////TODO &&(IsWithin(detail_visible_coords, Gbranch[i].pts_coords, Gbranch[i].no_points))
			)
		{

			UpdateBranchColor(i);

			if ((branch_dsp[i].pot_perc[horario] >
			     carregamento_overload) && (show_interval == 1))
			{
				glColor3fv(problem_branch_color);
				DrawPieChart(Gbranch[i].center[0],
					   Gbranch[i].center[1], 10.0,
					   problem_branch_color[0],
					   problem_branch_color[1],
					   problem_branch_color[2],
					   (int) branch_dsp[i].pot_perc[horario], 500);
				glColor3fv(problem_branch_color);

			}

			if (!show_interval)
			{
				if (mode == GL_SELECT)
				{
					glPushName (i);
					//printf("Branch number %i - BUS %i TO BUS %i\n", i, branch[i].tap_bus, branch[i].z_bus);
				}
			}
			
			//Normal transmission line
			if (branch[i].type == 0)
			{
				DrawTransmissionLine(&Gbranch[i]);
			}
			//It's a transformer!
			else
			{
				DrawTransformer(&Gbranch[i]);
			}
			if (mode == GL_SELECT)
			{
				glPopName ();
			}
			
			
			{
				int a = branch[i].tap_bus - 1;
		
				DrawBus(bus[a].number, &Gbus[a], 0, zf, info);
				DrawBusGenerator(&bus[a], &Gbus[a]);
				DrawBusLoad(bus[a].load_MW, &Gbus[a]);
				DrawBusSusceptance(bus[a].susceptance, &Gbus[a]);

				a = branch[i].z_bus - 1;
				DrawBus(bus[a].number, &Gbus[a], 0, zf, info);
				DrawBusGenerator(&bus[a], &Gbus[a]);
				DrawBusLoad(bus[a].load_MW, &Gbus[a]);
				DrawBusSusceptance(bus[a].susceptance, &Gbus[a]);
			}
		}
	}
	
	delete[] detail_visible_coords;*/
	//    glPushMatrix();
	//glMatrixMode (GL_PROJECTION);
	//glLoadIdentity ();	
	//gluOrtho2D(0, 70, 0, 70);
	//glTranslatef(yref, xref, 0);
	glTranslatef(90, 50, 0);
	//glMatrixMode (GL_MODELVIEW);
    
	
	glColor3f(0,0,1);
	glCallList(Mapa);
	glPopMatrix();
		
	//glColor3f(1,0,0);
	
	//glCallList(FirstLines);
	
	//glPopMatrix();	
	
	
	
		
	
	
	glFlush();	
	
}


void DetailCanvas::OnDoubleClick(wxMouseEvent &event)
{

}

void DetailCanvas::OnClick(wxMouseEvent &event)
{
//void processMouse(int button, int state, int x, int y) 
	GLint viewport[4];
	GLdouble mvmatrix[16], projmatrix[16];
	GLint realy; /* OpenGL y coordinate position */
	GLdouble wx, wy, wz;//, wxi, wyi, wzi, wxf, wyf, wzf; /* returned world x, y, z coords */
	GLuint selectBuf [BUFSIZE];
	GLint hits; 
	GLfloat *detail_visible_coords;
	
	if (!GetContext()) return;
	SetCurrent();	
	
	glGetIntegerv (GL_VIEWPORT, viewport);
	glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
	glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);

    /* viewport[3] is height of window in pixels */
	realy = viewport[3] - (GLint) event.m_y - 1;
	gluUnProject((GLdouble) event.m_x, (GLdouble) realy, 0.0, mvmatrix, 
				  projmatrix, viewport, &wx, &wy, &wz);   
	
	detail_visible_coords = GetVisibleArea();
	
	
	// if a mouse button is pressed along with the shift key then
	if (event.ShiftDown()) 
	{
		// if it is the right mouse button, it decrements the zoom factor and set the viewpoint to current mouse coordinates
		if (event.RightDown())
		{
			zf -= zf_inc;
			if (zf < zf_min)
			zf = zf_min;
			center[0] = wx;
			center[1] = wy;  
		}
			
		// if it is the left mouse button, the branch timeframe details window is shown
		else 
		if (event.LeftDown())
		{
			
			glSelectBuffer (BUFSIZE, selectBuf);
			
			(void) glRenderMode (GL_SELECT);
			
			glInitNames();
			glPushName(0);
			
			glMatrixMode (GL_PROJECTION);
			glPushMatrix ();
			glLoadIdentity ();
			
			/*  create 5x5 pixel picking region near cursor location */
			gluPickMatrix ((GLdouble) event.m_x, (GLdouble) realy, 5.0, 5.0, viewport);
			/* Bidimensional Orthographic Projection */
			gluOrtho2D (center[0]-max_coord[0] / (2*zf), center[0]+max_coord[0] / (2*zf),
				center[1]-max_coord[1] / (2*zf), center[1]+max_coord[1] / (2*zf));
			
			DrawDetail(GL_SELECT);
			
			glMatrixMode(GL_PROJECTION);
			glPopMatrix ();
			SwapBuffers();
			
			hits = glRenderMode(GL_RENDER);
			ProcessHits(hits, selectBuf);
		}
	}
	else // (!event.ShiftDown)
	{
		// increments the zoom factor and set the viewpoint to current mouse coordinates
		if (event.RightDown())
		{
			zf += zf_inc;      
			if (zf > zf_max)
			zf = zf_max;
			center[0] = wx;
			center[1] = wy;  
		}
		if (event.LeftDown())
		{
			c0x = center[0];
			c0y = center[1];
			cx = wx;
			cy = wy;
			panning = true;
		}	
		else
		if (event.LeftUp() && panning)
		{
			center[0] = c0x - (wx - cx)*PANSCALE;
			center[1] = c0y - (wy - cy)*PANSCALE;
			panning = false;
		}	
		
	}
	
	
	DetailWindow1->UpdateZoom(zf, false);
	Zoom();
	Refresh(false);
	delete[] detail_visible_coords;
}

void DetailCanvas::Zoom()
{
    int w, h;
    GetClientSize(&w, &h);

    if (GetContext())
    {
        SetCurrent();
        glViewport(0, 0, (GLint) w, (GLint) h);
		
		/* Switches to the projection matrix */
		glMatrixMode (GL_PROJECTION);
		/* Loads the identity matrix */
		glLoadIdentity ();
		/* Bidimensional Orthographic Projection */
		gluOrtho2D (center[0]-max_coord[0] / (2*zf), center[0]+max_coord[0] / (2*zf),
			center[1]-max_coord[1] / (2*zf), center[1]+max_coord[1] / (2*zf)) ;
		//gluOrtho2D(0, 70, 0, 70);
		/* Swithches to the geometrical transformations matrix */
		glMatrixMode (GL_MODELVIEW);
		
		/*glEnable (GL_LINE_SMOOTH);
		
		glEnable (GL_BLEND);
		glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glHint (GL_LINE_SMOOTH_HINT, GL_DONT_CARE);
		glLineWidth (1.5);		*/
    }	
}

void DetailCanvas::ProcessHits(GLint hits, GLuint buffer[])
{
	unsigned int i, j;
	GLuint names, *ptr;
	char tmp[15], branch_name_txt[15], tap_z_bus_txt[20], branch_load_txt[15];
	char *aux;
	
	printf ("hits = %d\n", hits);
	ptr = (GLuint *) buffer;
	if (hits == 1) 
	{
		for (i = 0; i < hits; i++) 
		{ /*  for each hit  */
			names = *ptr;
			//printf (" number of names for this hit = %d\n", names);
			ptr++;
			//printf(" z1 is %g;", (float) *ptr/0x7fffffff);
			ptr++;
			//printf(" z2 is %g\n", (float) *ptr/0x7fffffff);
			ptr++;
			if (names > 1) 
			{
				for (j = 0; j < names; j++) 
				{ /*  for each name */
					selected_branch = (int) *ptr;
					ptr++;
				}
				printf ("   Hit Branch %i ", selected_branch);
				printf("-- goes from bus %i to %i\n", branch[selected_branch].tap_bus, branch[selected_branch].z_bus);
	
				if (branch_dsp[selected_branch].max_pot > 0.0) 
				{
					gcvt(selected_branch, 4, tmp);
					BranchLoadWindow1->lbBranchNumber->SetLabel(wxString::FromAscii(tmp));
					/*					
					gcvt(branch[selected_branch].tap_bus, 4, tmp);
					aux = "From ";
					for (i=0; i<=strlen(aux); i++)
					{
						tap_z_bus_txt[i] = aux[i];
					}
					strcat(tap_z_bus_txt, tmp);
					gcvt(branch[selected_branch].z_bus, 4, tmp);
					strcat(tap_z_bus_txt, " to ");
					strcat(tap_z_bus_txt, tmp);
					*/
					gcvt(branch_dsp[selected_branch].pot[horario], 7, tmp);
					BranchLoadWindow1->lbBranchLoad->SetLabel(wxString::FromAscii(tmp));
					//glui_branch_name_txt = glui_evolution->add_statictext_to_panel(panel1, branch_name_txt);
					//glui_tap_z_bus_txt = glui_evolution->add_statictext_to_panel(panel1, tap_z_bus_txt);
					//glui_branch_load_txt = glui_evolution->add_statictext_to_panel(panel1, branch_load_txt);
					BranchLoadWindow1->Show();
					BranchLoadWindow1->Chart3->Zoom();
					BranchLoadWindow1->Refresh(false);
					BranchLoadWindow1->Raise();
					
				}
			}
		}
	}
}

void DetailCanvas::OnKeyDown(wxKeyEvent& event) //void keyboard(unsigned char key, int x, int y)
{
	if (wxWindow::FindFocus() != this) return;
	
	switch (event.GetKeyCode()) {
	/* Exit when <ESC> is pressed */
	case WXK_SPACE:	
		DetailWindow1->Show();
		DetailWindow1->Raise();
		break;
	case WXK_ESCAPE:
		if (panning)
		{
			panning = false;
			center[0] = c0x;
			center[1] = c0y;
			Zoom();
		}
		else
		{
			DetailWindow1->Close();
			DetailWindow1->UpdateZoom(zf, false);
			DetailWindow1->ckShowInfo->SetValue(bool(info));
			Zoom();
		}
		break;

	// Incremento de 5 graus no angulo de rotacao em torno de x
	case '=':
		zf += zf_inc;
		if (zf > zf_max)
		{
			zf = zf_max;
		}
		DetailWindow1->UpdateZoom(zf, false);
		Zoom();
		
		break;
	// Decreases the scale factor by 2 units 
	case '-':
		zf -= zf_inc;
		if (zf < zf_min)
		{
			zf = zf_min;
		}
		DetailWindow1->UpdateZoom(zf, false);
		Zoom();
		break;
	case WXK_UP:
		center[1] += 20.0;
		Zoom();
		break;
	case WXK_DOWN:
		center[1] -= 20.0;
		Zoom();
		break;
	case WXK_LEFT:
		center[0] -= 20.0;
		Zoom();
		break;
	case WXK_RIGHT:
		center[0] += 20.0;
		Zoom();
		break;
	case WXK_END:
		center[0] = max_coord[0]/2.0;
		center[1] = max_coord[1]/2.0;
		Zoom();
		break;
	// Restores the scene to its original state 
	case WXK_HOME:
		zf = 1.0; 
		center[0] = max_coord[0]/2.0;
		center[1] = max_coord[1]/2.0;
		Zoom();
		DetailWindow1->UpdateZoom(zf, false);
		break;
	
	// Displays or not the information onscreen 
	case 'i':
	case 'I':
		info = (info) ? 0 : 1;
		DetailWindow1->ckShowInfo->SetValue(bool(info));
		break;

	}
	Refresh(false);
}


void DetailCanvas::OnMouseMotion(wxMouseEvent &event)
{
	if (wxWindow::FindFocus() != this || !panning) return;
	
	if (event.LeftIsDown())
	{
		GLint viewport[4];
		GLdouble mvmatrix[16], projmatrix[16];
		GLint realy; /* OpenGL y coordinate position */
		GLdouble wx, wy, wz;//, wxi, wyi, wzi, wxf, wyf, wzf; /* returned world x, y, z coords */
		GLuint selectBuf [BUFSIZE];
		GLint hits;    
	
		glGetIntegerv (GL_VIEWPORT, viewport);
		glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
		glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);

		/* viewport[3] is height of window in pixels */
		realy = viewport[3] - (GLint) event.m_y - 1;
		gluUnProject((GLdouble) event.m_x, (GLdouble) realy, 0.0, mvmatrix, 
					  projmatrix, viewport, &wx, &wy, &wz);   
    
		//coords = GetVisibleArea();
		
/*		sx = 0.05 * (wx - center[0]);
		sy = 0.05 * (wy - center[1]);*/
		center[0] = c0x - (wx - cx)*PANSCALE;
		center[1] = c0y - (wy - cy)*PANSCALE;
		/*
		if (!MouseTimer.IsRunning()) 
		{
			MouseTimer.Start(100);
		}*/
		Zoom();
		Refresh(false);
		
	}
}
/*
void DetailCanvas::OnMouseTimer(wxTimerEvent &event)
{
	if (wxWindow::FindFocus() != this) 
	{
		MouseTimer.Stop();
		return;
	}
	
	center[0] -= sx;
	center[1] -= sy;

	Zoom();
	Refresh(false);
}
*/
