#ifndef DETAILVIEW_H
#define DETAILVIEW_H

#include <wx/wx.h>
#include <wx/glcanvas.h>
#include "vpDefs.h"
#include "vpAux.h"
//#include "vpSim.h"

#include "MainWindow.h"
#include "DetailWindow.h"
#include "SimulationWindow.h"
#include "BranchLoadWindow.h"
	
#define SQR(a) (a * a)

#define MOUSETIMER	1200

#define PANSCALE	0.6
class DetailCanvas: public wxGLCanvas {
//    friend class MyFrame;
public:
	DetailCanvas( wxWindow *parent, wxGLContext* other, wxWindowID id = wxID_ANY,
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = 0, const wxString& name = _T("DetailCanvas") );
    ~DetailCanvas();

    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    void OnEraseBackground(wxEraseEvent& event);
    //virtual void OnChar(wxKeyEvent& event);
    void OnEnterWindow(wxMouseEvent& event);
    void Render();
    void InitGL();
	void Zoom();

	void ProcessHits(GLint hits, GLuint buffer[]);
	void UpdateBranchColor(int branch_number);//Branch_Color
	void DrawDetail(GLenum mode);
	
	
	GLfloat zf, zf_min, zf_max, zf_inc;
	int info;	
	GLfloat center[2]; 
private:
	void OnDoubleClick(wxMouseEvent &event);
	void OnClick(wxMouseEvent &event);
	void OnKeyDown(wxKeyEvent& event);
	
	void OnMouseMotion(wxMouseEvent &event);
	void OnMouseTimer(wxTimerEvent &event);
	
    bool   m_init;
	
	bool panning;
	float cx, cy, c0x, c0y;
	
	GLfloat max_coord[2];
	
	
//	wxTimer MouseTimer;	
	
DECLARE_EVENT_TABLE()
};





#endif //DETAILVIEW_H
