#include "DetailWindow.h"

extern SimulationWindow* SimulationWindow1;
extern MainWindow* MainWindow1;

//	extern GLfloat zf_min, zf_max, zf;
	extern float sim_gen, old_gen;
	extern int sim_bus;
	extern int current_circuit;


DetailWindow::DetailWindow(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE)
{
    panel_1 = new wxPanel(this, -1);
    ckShowInfo = new wxCheckBox(this, CKSHOWINFO, wxT("Show Info"));
    lbZoom = new wxStaticText(this, -1, wxT(" Zoom: "));
    ZoomText = new wxTextCtrl(this, -1, wxT("1.000"));
    ZoomSlider = new wxSlider(this, -1, 1000, 100, 30000, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL|wxSL_AUTOTICKS);
    lbVoltageLevel = new wxStaticText(this, -1, wxT(" Voltage Level "));
    const wxString ceVoltageLevel_choices[] = {
        wxT("138 kV"),
        wxT("69 kV"),
        wxT("11 kV")
    };
    ceVoltageLevel = new wxChoice(this, CEVOLTAGELEVEL, wxDefaultPosition, wxDefaultSize, 3, ceVoltageLevel_choices, 0);
    btSimulation = new wxButton(this, BTSIMULATION, wxT("Simulation"));
    btClose = new wxButton(this, BTCLOSEDETAIL, wxT("Close"));

    set_properties();
    do_layout();
	
	
	btSimulation->Disable();
	
	wxFlexGridSizer* sizergl = new wxFlexGridSizer(1, 1, 0, 0);
	sizergl->AddGrowableCol(0, 0);
	sizergl->AddGrowableRow(0, 0);
	sizergl->Add(Canvas2 = new DetailCanvas(panel_1, MainWindow1->Canvas1->GetContext(), wxID_ANY), 0, wxEXPAND);
	panel_1->SetSizer(sizergl);
	
	_editing = false;
	ZoomSlider->SetRange(int(((DetailCanvas*)Canvas2)->zf_min*100),
						  int(((DetailCanvas*)Canvas2)->zf_max*100));
	UpdateZoom(((DetailCanvas*)Canvas2)->zf);
	//ZoomText->Set
	
	int h,w;
	GetSize(&w, &h);
	SetSize(w, 2*w/3);
	Layout();
}


BEGIN_EVENT_TABLE(DetailWindow, wxFrame)
    EVT_CHECKBOX(CKSHOWINFO, DetailWindow::OnShowInfoCheckbox)
    EVT_TEXT(-1, DetailWindow::OnZoomText)
    EVT_SCROLL(DetailWindow::OnZoomScroll)
    EVT_CHOICE(CEVOLTAGELEVEL, DetailWindow::OnVoltageLevelChoice)
    EVT_BUTTON(BTSIMULATION, DetailWindow::OnSimulationButton)
    EVT_BUTTON(BTCLOSEDETAIL, DetailWindow::OnCloseButton)
	EVT_CLOSE(DetailWindow::OnClose)
END_EVENT_TABLE();


void DetailWindow::set_properties()
{
    // begin wxGlade: DetailWindow::set_properties
    SetTitle(wxT("VisciPower: Detail Window"));
    ZoomText->SetMinSize(wxSize(50, 22));
    ZoomSlider->SetMinSize(wxSize(120,0));
    ceVoltageLevel->SetSelection(0);
    // end wxGlade
}


void DetailWindow::do_layout()
{
    // begin wxGlade: DetailWindow::do_layout
    wxFlexGridSizer* sizer_1 = new wxFlexGridSizer(2, 1, 0, 0);
    wxFlexGridSizer* grid_sizer_3 = new wxFlexGridSizer(1, 5, 0, 0);
    wxFlexGridSizer* SizerVoltageLevel = new wxFlexGridSizer(1, 2, 0, 0);
    wxFlexGridSizer* SizerZoom = new wxFlexGridSizer(1, 2, 0, 0);
    wxBoxSizer* sizer_2 = new wxBoxSizer(wxHORIZONTAL);
    sizer_1->Add(panel_1, 1, wxEXPAND, 0);
    grid_sizer_3->Add(ckShowInfo, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerZoom->Add(lbZoom, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_2->Add(ZoomText, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 0);
    sizer_2->Add(ZoomSlider, 1, wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerZoom->Add(sizer_2, 1, wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    grid_sizer_3->Add(SizerZoom, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerVoltageLevel->Add(lbVoltageLevel, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerVoltageLevel->Add(ceVoltageLevel, 0, 0, 0);
    grid_sizer_3->Add(SizerVoltageLevel, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    grid_sizer_3->Add(btSimulation, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    grid_sizer_3->Add(btClose, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    grid_sizer_3->AddGrowableCol(0);
    grid_sizer_3->AddGrowableCol(1);
    grid_sizer_3->AddGrowableCol(2);
    grid_sizer_3->AddGrowableCol(3);
    grid_sizer_3->AddGrowableCol(4);
    sizer_1->Add(grid_sizer_3, 1, wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SetAutoLayout(true);
    SetSizer(sizer_1);
    sizer_1->Fit(this);
    sizer_1->SetSizeHints(this);
    sizer_1->AddGrowableRow(0);
    sizer_1->AddGrowableCol(0);
    Layout();
    // end wxGlade
}


void DetailWindow::OnCloseButton(wxCommandEvent &event)
{
	Hide();
}

void DetailWindow::OnClose(wxCloseEvent &event)
{
	event.Veto();
	Hide();
}

void DetailWindow::OnSimulationButton(wxCommandEvent &event)
{
	sim_gen = old_gen;
	SimulationWindow1->scBus->SetValue(sim_bus);
	SimulationWindow1->UpdateGeneration(sim_gen);
	SimulationWindow1->Show();
	SimulationWindow1->Raise();
}

void DetailWindow::OnShowInfoCheckbox(wxCommandEvent &event)
{
	((DetailCanvas*)Canvas2)->info = (event.IsChecked());
	Refresh(false);
}

void DetailWindow::OnVoltageLevelChoice(wxCommandEvent &event)
{
	current_circuit = event.GetSelection() + 1;
	MainWindow1->ceVoltageLevel->SetSelection(event.GetSelection());
	Refresh(false);
}


void DetailWindow::OnZoomText(wxCommandEvent &event)
{
	double d;
	if (!_editing)
	{
		_editing = true;
		if (ZoomText->GetValue().ToDouble(&d))
		{
			ZoomSlider->SetValue(int(d * 100));
			((DetailCanvas*)Canvas2)->zf = d;
		}
		else
		{
			*ZoomText << ((DetailCanvas*)Canvas2)->zf;
		}
		UpdateZoom(((DetailCanvas*)Canvas2)->zf);
		_editing = false;
	}
}


void DetailWindow::OnZoomScroll(wxScrollEvent &event)
{
	
	if (!_editing)
	{
		_editing = true;
		ZoomText->Clear();
		((DetailCanvas*)Canvas2)->zf = float(ZoomSlider->GetValue())/100.0;
		*ZoomText << ((DetailCanvas*)Canvas2)->zf;
		
		UpdateZoom(((DetailCanvas*)Canvas2)->zf);
		_editing = false;
	}
}

void DetailWindow::UpdateZoom(float zoom, bool update)
{

	if (!_editing)
	{
		_editing = true;
		
		ZoomSlider->SetValue(int(zoom * 100));
		ZoomText->Clear();
		*ZoomText << zoom;
		((DetailCanvas*)Canvas2)->zf = zoom;
	
		_editing = false;
	}
	
	if (update)
	{
		((MainCanvas*)(MainWindow1->Canvas1))->Zoom();
		((DetailCanvas*)(Canvas2))->Zoom();
		
		Canvas2->Refresh(false);
		MainWindow1->Canvas1->Refresh(false);
	}
}
