#include <wx/wx.h>
#include <wx/image.h>

#ifndef DETAILWINDOW_H
#define DETAILWINDOW_H

#include "MainWindow.h"
#include "BranchLoadWindow.h"
#include "SimulationWindow.h"
#include "DetailView.h"

class DetailCanvas;

class DetailWindow: public wxFrame {
public:
    enum {
        CKSHOWINFO = 1025,
        CEVOLTAGELEVEL = 1027,
        BTSIMULATION = 1029,
        BTCLOSEDETAIL = 1031
    };

    DetailWindow(wxWindow* parent, int id, const wxString& title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_FRAME_STYLE);

private:
	bool _editing;
    void set_properties();
    void do_layout();

public:
    wxPanel* panel_1;
    wxCheckBox* ckShowInfo;
    wxStaticText* lbZoom;
    wxTextCtrl* ZoomText;
    wxSlider* ZoomSlider;
    wxStaticText* lbVoltageLevel;
    wxChoice* ceVoltageLevel;
    wxButton* btSimulation;
    wxButton* btClose;
	DetailCanvas* Canvas2;
protected:	
    DECLARE_EVENT_TABLE();

public:
    void OnShowInfoCheckbox(wxCommandEvent &event); 
    void OnZoomText(wxCommandEvent &event); 
    void OnZoomScroll(wxScrollEvent &event); 
    void OnVoltageLevelChoice(wxCommandEvent &event);
    void OnSimulationButton(wxCommandEvent &event); 
    void OnCloseButton(wxCommandEvent &event); 
	void OnClose(wxCloseEvent &event);
	void UpdateZoom(float zoom, bool update=true);
}; 


#endif // DETAILWINDOW_H
