#include "MainView.h"

extern FTFont *font10, *font18, *font12;

extern DetailWindow* DetailWindow1;
extern SimulationWindow* SimulationWindow1;
extern BranchLoadWindow* BranchLoadWindow1;
extern MainWindow* MainWindow1;


extern GeoLines **Lines1;

extern int ShowMap;




float xref=0, yref=0, zoom=1;

BEGIN_EVENT_TABLE(MainCanvas, wxGLCanvas)
    EVT_SIZE(MainCanvas::OnSize)
    EVT_PAINT(MainCanvas::OnPaint)
    EVT_ERASE_BACKGROUND(MainCanvas::OnEraseBackground)
    EVT_ENTER_WINDOW(MainCanvas::OnEnterWindow)
	EVT_LEFT_DCLICK(MainCanvas::OnDoubleClick)
	EVT_KEY_DOWN(MainCanvas::OnKeyDown)	
END_EVENT_TABLE()

int horario=-1;
int timeframe = 24; 

int line = 0;
int show_interval=0;
int sim_bus, selected_branch = -1;
float sim_gen, old_gen;
int current_circuit = 1;




GLint bus_num = BUS_NUM;
GLint branch_num = BRANCH_NUM;

extern BUS bus[BUS_NUM];
extern GBUS Gbus[BUS_NUM];
extern GBRANCH Gbranch[BRANCH_NUM];

extern float *EPointsCoord;
extern GLuint FirstLines;
extern GLuint Mapa;
extern GLuint Hidro;
extern GLuint teste;
//extern GeoData *EPointsCoord2;

GLfloat carregamento_overload=70.0;// carregamento_secure=60.0;


extern BRANCH branch[BRANCH_NUM];
//extern BUS_DSP bus_dsp[BUS_NUM];
extern BRANCH_DSP branch_dsp[BRANCH_NUM];


MainCanvas::MainCanvas(wxWindow *parent, wxWindowID id,
    const wxPoint& pos, const wxSize& size, long style, const wxString& name)
    : wxGLCanvas(parent, (wxGLCanvas*) NULL, id, pos, size, style|wxFULL_REPAINT_ON_RESIZE , name )
{
    m_init = false;
	
	zf = 1.0; /* Zoom Factor */
	info = 0;
	
	

	max_coord[0] = 2444.0;
	max_coord[1] = 1764.0;
    center[0] = max_coord[0]/2.0;
    center[1] = max_coord[1]/2.0;
	
}


MainCanvas::~MainCanvas()
{
	/*delete font10;
	delete font12;
	delete font18;*/
}

void MainCanvas::Render()
{
    wxPaintDC dc(this);

    if (!GetContext()) return;

    SetCurrent();
    // Init OpenGL once, but after SetCurrent
    if (!m_init)
    {
        InitGL();

		glClearColor (bkg1[0], bkg1[1], bkg1[2], bkg1[3]);
	
		center[0] = max_coord[0] / 2.0;
		center[1] = max_coord[1] / 2.0;

        m_init = true;
		
		Zoom();
    }

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	DrawMain(GL_RENDER);
///    glFlush();
    SwapBuffers();
}

void MainCanvas::OnEnterWindow( wxMouseEvent& WXUNUSED(event) )
{
    SetFocus();
}

void MainCanvas::OnPaint( wxPaintEvent& WXUNUSED(event) )
{
    Render();
}

void MainCanvas::OnSize(wxSizeEvent& event)
{
    // this is also necessary to update the context on some platforms
    wxGLCanvas::OnSize(event);
	Zoom();
	//event.Skip();
}

void MainCanvas::Zoom()
{
	    // set GL viewport (not called by wxGLCanvas::OnSize on all platforms...)
    int w, h;
    GetClientSize(&w, &h);

    if (GetContext())
    {
        SetCurrent();
//        glViewport(0, 0, (GLint) w, (GLint) h);
		
		/* Defines the output window's dimensions */
		glViewport (0, 0, w, h);
		
		/* Switches to the projection matrix */
		glMatrixMode (GL_PROJECTION);
		/* Loads the identity matrix */
		glLoadIdentity ();
		/* Bidimensional Orthographic Projection */
		gluOrtho2D (center[0]-max_coord[0] / (2*zf), center[0]+max_coord[0] / (2*zf),
			center[1]-max_coord[1] / (2*zf), center[1]+max_coord[1] / (2*zf)) ;
		
		//gluOrtho2D (0, 70,
		//	        0, 70) ;
		/* Swithches to the geometrical transformations matrix */
		glMatrixMode (GL_MODELVIEW);
		
    }

}

void MainCanvas::OnEraseBackground(wxEraseEvent& WXUNUSED(event))
{
  // Do nothing, to avoid flashing.
}

void MainCanvas::InitGL()
{
	/*char fontfile[] = "./fonts/arial.ttf";
	if (!wxFileExists(wxString::FromAscii(fontfile)))
	{	
		printf("Cannot find font file (%s).", fontfile);
		exit(1);
	}

	font10 = new FTGLPixmapFont(fontfile);
	font12 = new FTGLPixmapFont(fontfile);
	font18 = new FTGLPixmapFont(fontfile);
	
	
	if (font10->Error() || font12->Error() || font18->Error())
	{
		fprintf( stderr, "Failed to open font (%s).", fontfile);
		exit(1);
	}
	font10->FaceSize(12);	
	font12->FaceSize(14);	
	font18->FaceSize(20);*/
}


void MainCanvas::UpdateBranchColor(int branch_number)//Branch_Color
{
	int i;//, c1 = 0, c2 = 0;

	if (branch_number == selected_branch)
	{
		branch[branch_number].color[0] = 0.0;
		branch[branch_number].color[1] = 1.0;
		branch[branch_number].color[2] = 0.0;
	}
	else if (show_interval == 0)
	{
		for (i = 0; i < timeframe; i++)
		{
			if (branch_dsp[branch_number].pot_perc[i] >= carregamento_overload)
			{
				branch[branch_number].color[0] = 1.0;
				branch[branch_number].color[1] = 0.0;
				branch[branch_number].color[2] = 0.0;
				break;
			}
			else
			{
				branch[branch_number].color[0] = 0.0;
				branch[branch_number].color[1] = 0.0;
				branch[branch_number].color[2] = 1.0;
			}
		}
	}
	else
	{
		branch[branch_number].color[0] = branch_color[0];
		branch[branch_number].color[1] = branch_color[1];
		branch[branch_number].color[2] = branch_color[2];
	}

	glColor3fv(branch[branch_number].color);

}

void MainCanvas::DrawMain(GLenum mode)
{
	int i,j;
	GLfloat *visible_coords;
	GLfloat zf_bak = zf;

	zf = 1.0;

	//glPushMatrix();
	visible_coords = GetVisibleArea();

	/* Plot Branches */
	for (i = 0; i < branch_num; i++)
	{
		if ((branch_dsp[i].pot_perc[horario] > carregamento_overload)
		    && (branch[i].circuit > current_circuit)
		    && (show_interval == 1))
		{
			glColor3fv(problem_branch_color);
			//DrawCircunference(15.0, Gbranch[i].center[0], Gbranch[i].center[1], 1);
		}
		if 	((branch[i].circuit <= current_circuit) &&
			 (IsWithin(visible_coords, Gbranch[i].pts_coords, Gbranch[i].no_points)))
		{
			{
				int a = branch[i].tap_bus - 1;
		
				//DrawBus(bus[a].number, &Gbus[a], 1, zf, info);
				
				
				
				//DrawBusGenerator(&bus[a], &Gbus[a]);
				//DrawBusLoad(bus[a].load_MW, &Gbus[a]);
				//DrawBusSusceptance(bus[a].susceptance, &Gbus[a]);

				a = branch[i].z_bus - 1;
				//DrawBus(bus[a].number, &Gbus[a], 1, zf, info);
				//DrawBusGenerator(&bus[a], &Gbus[a]);
				//DrawBusLoad(bus[a].load_MW, &Gbus[a]);
				//DrawBusSusceptance(bus[a].susceptance, &Gbus[a]);
			}
			

			//Change back to the original branch color
			glColor3fv(branch_color);

			if ((branch_dsp[i].pot_perc[horario] > carregamento_overload) && (show_interval == 1))
			{
				glColor3fv(problem_branch_color);
				//DrawCircunference(15.0, Gbranch[i].center[0], Gbranch[i].center[1], 1);
			}

			if (!show_interval)
			{
				UpdateBranchColor(i);
			}

			//Normal transmission line
			if (branch[i].type == 0)
			{
				//DrawTransmissionLine(&Gbranch[i]);
			}
			//It's a transformer!
			else
			{
				//DrawTransformer(&Gbranch[i]);
			}
		}
	}
	
		
	if (!FirstLines)
	   FirstLines = LoadLineObj("public");
	
	if (!Mapa)
		Mapa = LoadLineObj("mesoregioes");
	
	if(!Hidro)
		Hidro = LoadLineObj("hidrografia");
		
	
	/*glPushMatrix();
	//glViewport (-30, -30 , 60, 60);
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	
	//gluOrtho2D(-70, 10, -40, 30);
	gluOrtho2D(0, 70, 0, 70);
	
	glTranslatef(90, 50, 0);
	
	
	//glCallList(FirstLines);
	
	for (i = 0; i< 300 ; i++)
   {
	   glBegin(GL_LINE_STRIP);
	   for (j=0; j< 2; j++)
	   {
		   
		   
		   glVertex2f(Lines1[i][j].x, Lines1[i][j].y);
		   //fprintf(stderr, "%f %f", Lines1[i][j].x, Lines1[i][j].y);
		   
	   }
	   glEnd();
   }
	
   */
	
	
	/*teste = glGenLists(1);
	glNewList(teste, GL_COMPILE);
	
	glBegin(GL_LINE_STRIP);
	   
	   
    glVertex2f(0, 0);
	glVertex2f(100, 0);
	glVertex2f(0, 100);
	glVertex2f(100, 100);
		  
	   
	glEnd();
	glEndList();*/
	
	
   //FirstLines = LoadLineObj("public");

    glPushMatrix();
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();	
	gluOrtho2D(0, 70*zoom, 0, 70*zoom);
	glTranslatef(yref, xref, 0);
	glTranslatef(90, 50, 0);
	glMatrixMode (GL_MODELVIEW);
    
	
	
		
	glColor3f(0,0,0);
	glCallList(Mapa);
	
	glColor3f(0,0,1);
	if (ShowMap) glCallList(Hidro);
	
	glColor3f(1,0,0);
	glCallList(FirstLines);
	
	
	glPopMatrix();
		
	//glColor3f(1,0,0);
	
	//glCallList(FirstLines);
	
	//glPopMatrix();	
	
	
	
		
	
	
	glFlush();	
	
	
	
	
	delete[] visible_coords;
	//glPopMatrix ();
	
	zf = zf_bak;
}

void MainCanvas::OnDoubleClick(wxMouseEvent &event)
{
	GLint viewport[4];
    GLdouble mvmatrix[16], projmatrix[16];
    GLint realy; // OpenGL y coordinate position
    GLdouble wx, wy, wz; // returned world x, y, z coords 
    
    if (!GetContext()) return;
    SetCurrent();
	
	
    glGetIntegerv(GL_VIEWPORT, viewport);
    glGetDoublev(GL_MODELVIEW_MATRIX, mvmatrix);
    glGetDoublev(GL_PROJECTION_MATRIX, projmatrix);
    
    // viewport[3] is height of window in pixels
    realy = viewport[3] - (GLint) event.m_y - 1;
    
    gluUnProject((GLdouble) event.m_x, (GLdouble) realy, 0.0, mvmatrix, projmatrix, viewport, &wx, &wy, &wz);
    
    // if the left mouse button is pressed, the Detail Window will be opened
  	// if ((state == GLUT_DOWN) && (button == GLUT_LEFT_BUTTON)) 

	((DetailCanvas*)(DetailWindow1->Canvas2))->center[0] = wx;
	((DetailCanvas*)(DetailWindow1->Canvas2))->center[1] = wy;


	
	((DetailCanvas*)(DetailWindow1->Canvas2))->Zoom();
	DetailWindow1->Show();
	DetailWindow1->Refresh(false);
	DetailWindow1->Raise();
}


void MainCanvas::OnKeyDown(wxKeyEvent& event) //void keyboard(unsigned char key, int x, int y)
{
		
	/*glPushMatrix();
	EPointsCoord = vpRead_Uhe_geo();
	DrawUheGeo(EPointsCoord, 0, 0, 1);
	glPopMatrix();*/

//	DrawUheGeo(EPointsCoord, xref, yref, zoom);
	
	switch (event.GetKeyCode()) {
	case WXK_SPACE:	
		((DetailCanvas*)(DetailWindow1->Canvas2))->Zoom();
		DetailWindow1->Show();
		DetailWindow1->Refresh(false);
		DetailWindow1->Raise();		
		break;
	case WXK_UP:
		yref+=1;	
		break;
	case WXK_LEFT:
		xref+=1;
		break;
	case WXK_RIGHT:
		xref-=1;
		
		break;
	case WXK_DOWN:
		yref-=1;
		
	
		
		break;
	

	
	//case WXK_
	}
	DrawMain(GL_RENDER);
}
