#ifndef MAINVIEW_H
#define MAINVIEW_H

#include <wx/wx.h>
#include <wx/glcanvas.h>
#include <wx/textdlg.h>
//#include <mysql.h>
#include "vpDefs.h"
#include "vpAux.h"
#include "vpSim.h"


#include "MainWindow.h"
#include "DetailWindow.h"
#include "SimulationWindow.h"
#include "BranchLoadWindow.h"

	
class MainCanvas: public wxGLCanvas {
//    friend class MyFrame;
public:
    MainCanvas( wxWindow *parent, wxWindowID id = wxID_ANY,
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = 0, const wxString& name = _T("MainCanvas") );
    ~MainCanvas();

    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    void OnEraseBackground(wxEraseEvent& event);
    //virtual void OnChar(wxKeyEvent& event);
	void OnKeyDown(wxKeyEvent& event);
    void OnEnterWindow(wxMouseEvent& event);
    void Render();
    void InitGL();
	void Zoom();
	void ReadData();
	void InitData();
	
	void UpdateBranchColor(int branch_number);//Branch_Color

	void DrawMain(GLenum mode);
	
	GLfloat zf;
	int info;	
	
private:
	void OnDoubleClick(wxMouseEvent &event);

    bool   m_init;
	
	
	GLfloat max_coord[2];
	GLfloat center[2];
DECLARE_EVENT_TABLE()
};





#endif //MAINVIEW_H
