#include "MainWindow.h"
extern DetailWindow* DetailWindow1;
extern SimulationWindow* SimulationWindow1;
extern BranchLoadWindow* BranchLoadWindow1;
extern MainWindow* MainWindow1;


extern int current_circuit;
extern int horario;
extern int line;
extern int info, principal, show_interval;

int ShowMap=0;


BEGIN_EVENT_TABLE(MainWindow, wxFrame)
	EVT_TIMER(ANIMATIONTIMER, MainWindow::OnAnimationTimer)
//	EVT_LEFT_DCLICK(MainWindow::OnDoubleClick)
    EVT_CHECKBOX(CKINTERVALMODE, MainWindow::OnIntervalModeCheckbox)
    EVT_SPINCTRL(SCHOUR, MainWindow::OnHourSpin)
    EVT_BUTTON(BTCHANGECONSTRAINTS, MainWindow::OnChangeConstraintsButton)
    EVT_BUTTON(BTTOGGLEANIMATION, MainWindow::OnToggleAnimationButton)
    EVT_CHOICE(CEVOLTAGELEVEL, MainWindow::OnVoltageLevelChoice)
    EVT_BUTTON(wxID_EXIT, MainWindow::OnQuitButton)
END_EVENT_TABLE();

void MainWindow::set_properties()
{
    // begin wxGlade: MainWindow::set_properties
    SetTitle(wxT("Viscipower - Main Window"));
    SetSize(wxSize(800, 500));
    plLeftTop->SetBackgroundColour(wxColour(58, 137, 255));
    plLeftBottom->SetBackgroundColour(wxColour(255, 5, 50));
    plRight->SetBackgroundColour(wxColour(250, 255, 5));
    scHour->Enable(false);
    btChangeConstraints->Enable(false);
    ceVoltageLevel->SetSelection(0);
    // end wxGlade
}

void MainWindow::do_layout()
{
    // begin wxGlade: MainWindow::do_layout
    wxFlexGridSizer* SizerMain = new wxFlexGridSizer(2, 1, 0, 0);
    wxFlexGridSizer* SizerBottom = new wxFlexGridSizer(1, 7, 4, 12);
    wxFlexGridSizer* SizerVoltageLevel = new wxFlexGridSizer(1, 2, 0, 4);
    wxFlexGridSizer* object_8 = new wxFlexGridSizer(2, 1, 0, 0);
    wxGridSizer* SizerHour = new wxGridSizer(1, 2, 0, 4);
    wxFlexGridSizer* grid_sizer_1 = new wxFlexGridSizer(1, 1, 0, 0);
    window_2->SplitHorizontally(plLeftTop, plLeftBottom);
    grid_sizer_1->Add(window_2, 1, wxEXPAND, 0);
    window_1_pane_1->SetAutoLayout(true);
    window_1_pane_1->SetSizer(grid_sizer_1);
    grid_sizer_1->Fit(window_1_pane_1);
    grid_sizer_1->SetSizeHints(window_1_pane_1);
    grid_sizer_1->AddGrowableRow(0);
    grid_sizer_1->AddGrowableCol(0);
    window_1->SplitVertically(window_1_pane_1, plRight, 267);
    SizerMain->Add(window_1, 1, wxEXPAND, 0);
    SizerBottom->Add(1, 1, 0, wxEXPAND, 0);
    object_8->Add(ckIntervalMode, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerHour->Add(lbHour, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerHour->Add(scHour, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    object_8->Add(SizerHour, 0, 0, 0);
    SizerBottom->Add(object_8, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerBottom->Add(btChangeConstraints, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerBottom->Add(btToggleAnimation, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerVoltageLevel->Add(lbVoltageLevel, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerVoltageLevel->Add(ceVoltageLevel, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerBottom->Add(SizerVoltageLevel, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerBottom->Add(btQuit, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SizerBottom->Add(1, 1, 0, wxEXPAND, 0);
    SizerBottom->AddGrowableCol(6);
    SizerMain->Add(SizerBottom, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SetAutoLayout(true);
    SetSizer(SizerMain);
    SizerMain->AddGrowableRow(0);
    SizerMain->AddGrowableCol(0);
    Layout();
    // end wxGlade
}	

MainWindow::MainWindow(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
	wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE),
	AnimationTimer(this, ANIMATIONTIMER)	

{
    // begin wxGlade: MainWindow_::MainWindow_
    window_1 = new wxSplitterWindow(this, -1, wxDefaultPosition, wxDefaultSize, wxSP_3D|wxSP_BORDER);
    window_1_pane_1 = new wxPanel(window_1, -1);
    window_2 = new wxSplitterWindow(window_1_pane_1, -1, wxDefaultPosition, wxDefaultSize, wxSP_3D|wxSP_BORDER);
    plLeftTop = new wxPanel(window_2, PLLEFTTOP);
    plLeftBottom = new wxPanel(window_2, PLLEFTBOTTOM);
    plRight = new wxPanel(window_1, PLRIGHT);
    ckIntervalMode = new wxCheckBox(this, CKINTERVALMODE, wxT("Interval Mode"));
    lbHour = new wxStaticText(this, LBHOUR, wxT("Hour"));
    scHour = new wxSpinCtrl(this, SCHOUR, wxT("0"), wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 0, 23);
    btChangeConstraints = new wxButton(this, BTCHANGECONSTRAINTS, wxT("&Change Constraints"));
    btToggleAnimation = new wxButton(this, BTTOGGLEANIMATION, wxT("&Toggle Animation"));
    lbVoltageLevel = new wxStaticText(this, LBVOLTAGELEVEL, wxT("Voltage Level"));
    const wxString ceVoltageLevel_choices[] = {
        wxT("138 kV"),
        wxT("69 kV"),
        wxT("11 kV")
    };
    ceVoltageLevel = new wxChoice(this, CEVOLTAGELEVEL, wxDefaultPosition, wxDefaultSize, 3, ceVoltageLevel_choices, 0);
    btQuit = new wxButton(this, wxID_EXIT, wxT("&Quit"));

    set_properties();
    do_layout();
    // end wxGlade

	/*wxFlexGridSizer* sizergl1 = new wxFlexGridSizer(1, 1, 0, 0);
	sizergl1->AddGrowableCol(0, 0);
	sizergl1->AddGrowableRow(0, 0);
	sizergl1->Add(Chart1 = new DemandChart(plLeftTop, CHART1), 0, wxEXPAND);	
	plLeftBottom->SetSizer(sizergl1);

	wxFlexGridSizer* sizergl2 = new wxFlexGridSizer(1, 1, 0, 0);
	sizergl2->AddGrowableCol(0, 0);
	sizergl2->AddGrowableRow(0, 0);
	sizergl2->Add(Chart2 = new LoadChart(plLeftBottom, wxID_ANY), 0, wxEXPAND);	
	plLeftTop->SetSizer(sizergl2);

	
	wxFlexGridSizer* sizergl3 = new wxFlexGridSizer(1, 1, 0, 0);
	sizergl3->AddGrowableCol(0, 0);
	sizergl3->AddGrowableRow(0, 0);
	sizergl3->Add(Canvas1 = new MainCanvas(plRight, CANVAS1), 0, wxEXPAND);
	plRight->SetSizer(sizergl3);
	*/
	window_1->SetSashGravity(0.5);
	window_1->SetMinimumPaneSize(50);

	window_2->SetSashGravity(0.5);
	window_2->SetMinimumPaneSize(50);
	
	window_1->ReplaceWindow(plRight, Canvas1 = new MainCanvas(window_1, CANVAS1));
	window_2->ReplaceWindow(plLeftTop, Chart1 = new DemandChart(window_2, Canvas1->GetContext(), CHART1));
	window_2->ReplaceWindow(plLeftBottom, Chart2 = new LoadChart(window_2, Canvas1->GetContext(), CHART2));
	delete plRight;
	delete plLeftBottom;
	delete plLeftTop;
	
	animation = 0;
}

MainWindow::~MainWindow()
{
/*	delete BranchLoadWindow1;
	delete SimulationWindow1;
	delete DetailWindow1;
	delete Canvas1;*/
}

void MainWindow::OnQuitButton(wxCommandEvent &event)
{
    Close(true);
}

void MainWindow::OnChangeConstraintsButton(wxCommandEvent &event)
{
	extern float sim_gen, old_gen;
	extern int sim_bus;
	sim_gen = old_gen;
	SimulationWindow1->scBus->SetValue(sim_bus);
	SimulationWindow1->UpdateGeneration(sim_gen);
	SimulationWindow1->Show();
	SimulationWindow1->Raise();
}

void MainWindow::OnVoltageLevelChoice(wxCommandEvent &event)
{
	current_circuit = event.GetSelection() + 1;
	DetailWindow1->ceVoltageLevel->SetSelection(event.GetSelection());
	Refresh(false);
}

void MainWindow::OnShowMapCheckBox(wxCommandEvent &event)
{


}

void MainWindow::OnHourSpin(wxSpinEvent &event)
{
	horario = event.GetPosition();
	line = 1;
	Refresh(false);
	DetailWindow1->Refresh(false);
}


void MainWindow::OnIntervalModeCheckbox(wxCommandEvent &event)
{

	if (event.IsChecked())
	{
		show_interval = 1;
		horario = 0;
		line = 1;
		scHour->Enable(); //spinner->enable();
//		sim_panel->enable();
		btChangeConstraints->Enable(); //simula->enable();
//		anim_panel->disable();
		btToggleAnimation->Disable(); //anima->disable();
		if (DetailWindow1) 
		{
			//sim_panel_detail->enable();
			DetailWindow1->btSimulation->Enable(); //simula_detail->enable();
		}
	}
	else
	{
		show_interval = 0;
		horario = -1;
		line = 0;
		scHour->Disable(); 
		btChangeConstraints->Disable(); 
		btToggleAnimation->Enable(); 
		if (DetailWindow1) 
		{
			DetailWindow1->btSimulation->Disable(); 
		}
	}
	Refresh(false);
	
	if (event.IsChecked())
	{
		ShowMap = 1;		
	}else
		ShowMap =0;
	MainWindow1->Refresh(false);
	
}



void MainWindow::OnToggleAnimationButton(wxCommandEvent &event)
{
	if (animation == 0) 
		animation =	1;
	else 
	{
		animation = 0;
		show_interval = 0;
		line = 0;
		horario = -1;
		btToggleAnimation->SetLabel(_T("Animate"));
		ckIntervalMode->Enable();
		AnimationTimer.Stop();
		Refresh(false);
		DetailWindow1->Refresh(false);
		BranchLoadWindow1->Refresh(false);		
	}

	if (animation == 1) 
	{
		horario = 0;
		line = 1;
		show_interval = 1;
		btToggleAnimation->SetLabel(_T("Stop!"));
		ckIntervalMode->Disable();
		AnimationTimer.Start(1000);
	}
}


void MainWindow::OnAnimationTimer(wxTimerEvent& event)
{
    horario++;
    if (horario>23) horario = 0;
	Refresh(false);
	DetailWindow1->Refresh(false);
	BranchLoadWindow1->Refresh(false);
}
