#include <wx/wx.h>
#include <wx/image.h>

#ifndef SIMULATIONWINDOW_H
#define SIMULATIONWINDOW_H

#include <wx/spinctrl.h>

#include "DetailWindow.h"
#include "MainWindow.h"
#include "BranchLoadWindow.h"
#include "vpDefs.h"
#include "vpSim.h"


class SimulationWindow: public wxFrame {
public:
    enum {
        SCBUS = 1015,
        BTSIMULATE = 1017,
        BTRESETSIM = 1019
    };

    SimulationWindow(wxWindow* parent, int id, const wxString& title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_FRAME_STYLE);

	wxTextCtrl* GenerationText;
	wxSlider* GenerationSlider;
	wxSpinCtrl* scBus;
	
private:
    void set_properties();
    void do_layout();

protected:
    wxStaticText* lbBus;
    wxStaticText* lbBusGeneration;
    wxButton* btSimulate;
    wxButton* btReset;
	
	bool _editing;

    DECLARE_EVENT_TABLE();

public:
    void OnscBus(wxSpinEvent &event); 
    void OnGenerationText(wxCommandEvent &event);
    void OnGenerationScroll(wxScrollEvent &event); 
    void OnbtSimulate(wxCommandEvent &event); 
    void OnbtReset(wxCommandEvent &event); 
	void OnClose(wxCloseEvent &event);	
	
	void UpdateGeneration(float gen);
}; 


#endif // SIMULATIONWINDOW_H
