#include <wx/wx.h>
#include <wx/image.h>

#include "MainWindow.h"
#include "DetailWindow.h"
#include "SimulationWindow.h"
#include "BranchLoadWindow.h"
#include "vpSim.h"

// !!!! SEMPRE QUE EDITAR A INTERFACE COM WXGLADE,		  	!!!!
// !!!! COLOCAR "virtual" ANTES DOS EVENTOS SOBRESCRITOS	!!!!

DetailWindow* DetailWindow1;
SimulationWindow* SimulationWindow1;
BranchLoadWindow* BranchLoadWindow1;
MainWindow* MainWindow1;

extern FTFont *font10, *font18, *font12;


class VisciPower: public wxApp {
public:
    bool OnInit();
	int  OnExit();
};

IMPLEMENT_APP(VisciPower)

bool VisciPower::OnInit()
{
	char fontfile[] = "./fonts/arial.ttf";
	if (!wxFileExists(wxString::FromAscii(fontfile)))
	{	
		printf("Cannot find font file (%s).", fontfile);
		exit(1);
	}

	font10 = new FTGLPixmapFont(fontfile);
	font12 = new FTGLPixmapFont(fontfile);
	font18 = new FTGLPixmapFont(fontfile);
	
	
	if (font10->Error() || font12->Error() || font18->Error())
	{
		fprintf( stderr, "Failed to open font (%s).", fontfile);
		exit(1);
	}
	font10->FaceSize(12);	
	font12->FaceSize(14);	
	font18->FaceSize(20);
	

	vpReadData();
	//vpRead_Uhe_geo();
	//vpInitData();

	
    wxInitAllImageHandlers();
    
	// Instantiate all windows
	MainWindow1 = new MainWindow(0, -1, _T(""));
	DetailWindow1 = new DetailWindow(MainWindow1, -1, _T(""));
	SimulationWindow1 = new SimulationWindow(MainWindow1, -1, _T(""));
	BranchLoadWindow1 = new BranchLoadWindow(MainWindow1, -1, _T(""));

	// Show Main Window
    SetTopWindow(MainWindow1);
    MainWindow1->Show();
	
	
    return true;
}

int VisciPower::OnExit()
{
	/*delete BranchLoadWindow1;
	delete SimulationWindow1;
	delete DetailWindow1;
	delete MainWindow1;*/
	delete font10;
	delete font12;
	delete font18;
	
	// return value is currently ignored
    return 0;
}
