#include "vpAux.h"

FTFont 	*font10 = NULL, 
		*font18 = NULL,
		*font12 = NULL;

GLfloat bus_color[3] = {0.0, 0.0, 1.0}; /* Bus Color */
GLfloat text_color[3] = {0.0, 0.0, 0.0}; /* Text Color */

extern GLuint teste;
extern wxString pass;
extern wxString user;
extern wxString db;
extern wxString dbtable;
extern wxString host;

void DrawCircunference(double r, double x, double y, int fill)
{
    double angle;
    double x1,y1;
    
    if (fill == 0)
	{
		glBegin(GL_LINE_LOOP);
	}
    else
	{
		glBegin(GL_POLYGON);
	}
	
    for(angle=0;angle<=360.0;angle+=0.5)
    {
		x1=x+r*cos(angle*M_PI/180);
		y1=y+r*sin(angle*M_PI/180);
		glVertex2f(x1,y1);
    }
    glEnd();
}

void DrawPieChart(GLfloat center_x, GLfloat center_y, GLfloat radius, GLfloat color_1, GLfloat color_2, GLfloat color_3, GLfloat percentage, GLint num_points)
{
    int aux;
    GLfloat angle, comp_angle;
    char pcnt[6];  
    GLUquadricObj *qobj;
    
    angle = (percentage/100.0) * 360;
    comp_angle = 360.0 - angle; 
    
    aux = int(percentage);
    gcvt(aux, 6, pcnt);
    
    glColor3f (color_1, color_2, color_3);
    glTranslatef(center_x, center_y, 0.0);
    qobj = gluNewQuadric();
    gluQuadricDrawStyle(qobj, GLU_SILHOUETTE);
    gluQuadricNormals(qobj, GLU_NONE);
    gluPartialDisk(qobj, 0.0, radius, num_points, 1, 90.0, comp_angle);
    gluQuadricDrawStyle(qobj, GLU_FILL);
    gluPartialDisk(qobj, 0.0, radius, num_points, 1, 90.0, -angle);
    gluDeleteQuadric(qobj);
    glTranslatef(-center_x, -center_y, 0.0);
    ////glFlush();
    glColor3f (0.0, 0.0, 0.0);

	DRAWTEXT(center_x-2.0, center_y-1.0, strcat(pcnt, "%"), font10);
	
//	glRasterPos2f(center_x-2.0, center_y-1.0);
//	font->Render("teste");//strcat(pcnt, "%")
	
//    glFlush();
}

void DrawGenerator(GLint dir, GLfloat x, GLfloat y/*, char *gen_MW, char *gen_MVAR*/)
{
    
    GLfloat ctrlpoints[4][3];
    int i;
    GLfloat aux;
    
    glPushMatrix();
    glTranslatef(x, y, 0.0);
    
    switch (dir) {
    case 2: //Direction is equal to 2 (Generator is downwards)
		glRotatef(180.0, 0.0, 0.0, 1.0);
	break;
    case 3: //Direction is equal to 3 (Generator is headed right)
		glRotatef(-90.0, 0.0, 0.0, 1.0);
	break;
    case 4: //Direction is equal to 4 (Generator is headed left)
		glRotatef(90.0, 0.0, 0.0, 1.0);
	break;
    }
    
    //Plot the first line
    glBegin(GL_LINES);
    glVertex2f(0.0, 0.0);
    glVertex2f(0.0, 15.0);
    glEnd();
    
    //Plot the circunference(radius, center_x, center_y)
    DrawCircunference(5.5, 0.0, 20.5, 0);
    
    //Plot the ~
    ctrlpoints[0][0] = -4.0;
    ctrlpoints[0][1] = 20.5;
    ctrlpoints[0][2] = 0.0;
    ctrlpoints[1][0] = 0.0;
    ctrlpoints[1][1] = 29.0;
    ctrlpoints[1][2] = 0.0;
    ctrlpoints[2][0] = 0.0;
    ctrlpoints[2][1] = 12.0;
    ctrlpoints[2][2] = 0.0;
    ctrlpoints[3][0] = 4.0;
    ctrlpoints[3][1] = 20.5;
    ctrlpoints[3][2] = 0.0;
    glMap1f(GL_MAP1_VERTEX_3, 0.0, 1.0, 3, 4,&ctrlpoints[0][0]);
    glEnable(GL_MAP1_VERTEX_3);
    glBegin(GL_LINE_STRIP);
    
	for (i = 0; i <= 30; i++) 
	{
		glEvalCoord1f((GLfloat) i/30.0);
	}
	glEnd();
    
    //Plot the second line
    glBegin(GL_LINES);
    glVertex2f(0.0, 26.0);
    glVertex2f(0.0, 32.0);
    glEnd();
    
    //Plot the ground symbol
    glBegin(GL_LINES);
    glVertex2f(-5.0, 32.0);
    glVertex2f(5.0, 32.0);
    glEnd();
    aux = -6.5;
    for (i = 0; i < 10.0; i++)
	{
		glBegin(GL_LINES);
		glVertex2f(aux, 34.5);
		glVertex2f(aux+2.0, 32.0);
		glEnd();
		aux++;
    }
    
    //    if (info) {
    // switch (dir) {
    // case 1: //Direction is equal to 1 (Generator is upwards)
    //     DRAWTEXT(-150.0/zf, 7.0/zf + zf*3, gen_MW, font10);
    //     DRAWTEXT(-150.0/zf, 3.0/zf + zf*3, gen_MVAR, font10);
    //     break;
    // case 2: //Direction is equal to 2 (Generator is downwards)
    //     DRAWTEXT(150.0/zf, 3.0/zf, gen_MW, font10);
    //     DRAWTEXT(150.0/zf, 7.0/zf, gen_MVAR, font10);
    //     break;
    // case 3: //Direction is equal to 3 (Generator is headed right)
    //     DRAWTEXT(100.0/zf, 5.0, gen_MW, font10);
    //     DRAWTEXT(150.0/zf, 5.0, gen_MVAR, font10);
    //     break;
    // case 4: //Direction is equal to 4 (Generator is headed left)
    //     DRAWTEXT(-100.0/zf, 10.0, gen_MW, font10);
    //     DRAWTEXT(-150.0/zf, 10.0, gen_MVAR, font10);
    //     break;
    // }
    //    }
    glPopMatrix();
}

void DrawLoad(GLint dir, GLfloat x, GLfloat y)
{
    glPushMatrix();
    glTranslatef(x, y, 0.0);
    
    switch (dir) {
    case 2: //Direction is equal to 2 (Load is downwards)
		glRotatef(180.0,0.0,0.0,1.0) ;
	break;
    case 3: //Direction is equal to 3 (Load is headed right)
		glRotatef(-90.0,0.0,0.0,1.0) ;
	break;
    case 4: //Direction is equal to 4 (Load is headed left)
		glRotatef(90.0,0.0,0.0,1.0) ;
	break;
    }
    
    //Plot a straight line
    glBegin(GL_LINES);
    glVertex2f(0.0, 0.0);
    glVertex2f(0.0, 20.0);
    glEnd();
    
    //Plot the "head" of the arrow
    glBegin(GL_POLYGON);
    glVertex2f(0.0, 20.0);
    glVertex2f(-1.5, 14.0);
    glVertex2f(1.5, 14.0);
    glEnd();
    
    glPopMatrix();
}

void DrawSusceptance(GLint dir, GLfloat x, GLfloat y)
{
    glPushMatrix();
    glTranslatef(x, y, 0.0);
    
    switch (dir) {
    case 2: //Direction is equal to 2 (Susceptance is downwards)
		glRotatef(180.0, 0.0, 0.0, 1.0);
	break;
    case 3: //Direction is equal to 3 (Susceptance is headed right)
		glRotatef(-90.0, 0.0, 0.0, 1.0);
	break;
    case 4: //Direction is equal to 4 (Susceptance is headed left)
		glRotatef(90.0, 0.0, 0.0, 1.0);
	break;
    }
    
    //Plot a straight line
    glBegin(GL_LINES);
    glVertex2f(0.0, 0.0);
    glVertex2f(0.0, 20.0);
    glEnd();
    
    //Plot the top symbol of Susceptance
    glBegin(GL_LINE_STRIP);
    glVertex2f(-1.5, 14.0);
    glVertex2f(-1.5, 21.5);
    glVertex2f(1.5, 21.5);
    glVertex2f(1.5, 14.0);
    glEnd();
    
    glPopMatrix();
}

void DrawBusGenerator(BUS *abus, GBUS *agbus)
{
    //int j, aux;
    //char gen_MW[9];
    //char gen_MVAR[9];
    
    //If Bus has a Generator - Field "type"= 2 or 3 in the Bus structure
    if ((abus->type == 2)||(abus->type == 3)) 
	{
	/*aux = bus[i].gen_MW;
	gcvt(aux, 7, gen_MW);
	aux = bus[i].gen_MVAR;
	gcvt(aux, 7, gen_MVAR);
	//Sets 2 digits after the dot
	for (j=0; j<strlen(gen_MW); j++){
	    if (gen_MW[j] == '.')
		gen_MW[j+3] = 0;
	}
	for (j=0; j<strlen(gen_MVAR); j++){
	    if (gen_MVAR[j] == '.')
		gen_MVAR[j+3] = 0;
	}
	strcat(gen_MW, " MW");
	strcat(gen_MVAR, " MVAR");*/
	//if (ABS(agbus->Gen_x) > 1e-5 || ABS(agbus->Gen_y) > 1e-5)
	if (agbus->Gen_x > 0.0 || agbus->Gen_y > 0.0)
		DrawGenerator(agbus->Gen_dir, agbus->Gen_x, agbus->Gen_y/*, gen_MW, gen_MVAR*/);
	
    }
}
void DrawBusLoad(GLfloat busloadmw, GBUS *agbus)
{    
    //If Bus has a Load - Field "load_MW" in the Bus structure
    if (busloadmw > 0.0 && (agbus->Load_x > 0.0 || agbus->Load_y > 0.0)) 
	{
		DrawLoad(agbus->Load_dir, agbus->Load_x, agbus->Load_y);
    }
}

void DrawBusSusceptance(GLfloat bussusc, GBUS *agbus)
{
    //If Bus has Susceptance - Field "susceptance" in the Bus structure
	if (bussusc > 0.0 && (agbus->Suscep_x > 0.0 || agbus->Suscep_y > 0.0)) 
	{
		DrawSusceptance(agbus->Suscep_dir, agbus->Suscep_x, agbus->Suscep_y);
    }
}

void DrawBus(int busnumber, GBUS *agbus, bool alternate, GLfloat zf, int info)
{
    int j;
    char number[3];
    
    glLineWidth(3.0*zf);
    glPointSize((alternate ? 2.5 : 2.0)*zf);
    glColor3fv(bus_color);
    j = busnumber;  
    gcvt(j, 3, number); 
    if ((agbus->xi == agbus->xf)&&(agbus->yi == agbus->yf)) 
	{
		glEnable(GL_POINT_SMOOTH);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);
		glBegin(GL_POINTS);
		glVertex2f(agbus->xi, agbus->yi);
		glEnd();
		glDisable(GL_POINT_SMOOTH);
    }
    else 
	{
		glBegin(GL_LINES);
		glVertex2f(agbus->xi, agbus->yi);
		glVertex2f(agbus->xf, agbus->yf);
		glEnd();
    }
    if (info) 
	{
		glColor3fv(text_color);
		DRAWTEXT(agbus->xi-(alternate ? 5.0 : 60.0)/zf, agbus->yi-2, number, font10);
		glColor3fv(bus_color);
    }
    glLineWidth(1.0);
    glPointSize(1.0);
} 


void DrawTransformer(GBRANCH *agbranch)
{
	int j;
	GLfloat x, y;	
	
	glBegin (GL_LINE_STRIP);
	for (j = 0; j < agbranch->no_points * 2; j += 2)
	{
		if (agbranch->pts_coords[j] > 0.0)
		{
			glVertex2f (agbranch->pts_coords[j], agbranch->pts_coords[j + 1]);
		}
		else
		{
			glEnd ();
			x = agbranch->pts_coords[j - 2];
			y = agbranch->pts_coords[j - 1];
			//begins drawing the transformer, according to the direction
			glBegin (GL_LINE_STRIP);
			switch ((int)(agbranch->pts_coords[j]))
			{
			case -1:	//Direction is equal to -1 (Transformer is drawn upwards)
				glVertex2f (x - 6.0, y + 4.0);
				glVertex2f (x - 4.0, y);
				glVertex2f (x - 2.0, y + 4.0);
				glVertex2f (x, y);
				glVertex2f (x + 2.0, y + 4.0);
				glVertex2f (x + 4.0, y);
				glVertex2f (x + 6.0, y + 4.0);
				glEnd ();
				glBegin (GL_LINE_STRIP);
				glVertex2f (x - 6.0, y + 6.0);
				glVertex2f (x - 4.0, y + 10.0);
				glVertex2f (x - 2.0, y + 6.0);
				glVertex2f (x, y + 10.0);
				glVertex2f (x + 2.0, y + 6.0);
				glVertex2f (x + 4.0, y + 10.0);
				glVertex2f (x + 6.0, y + 6.0);
				glEnd ();
				glBegin (GL_LINE_STRIP);
				glVertex2f (x, y + 10.0);
				break;
			case -2:	//Direction is equal to -2 (Transformer is drawn downwards)
				glVertex2f (x - 6.0, y - 4.0);
				glVertex2f (x - 4.0, y);
				glVertex2f (x - 2.0, y - 4.0);
				glVertex2f (x, y);
				glVertex2f (x + 2.0, y - 4.0);
				glVertex2f (x + 4.0, y);
				glVertex2f (x + 6.0, y - 4.0);
				glEnd ();
				glBegin (GL_LINE_STRIP);
				glVertex2f (x - 6.0, y - 6.0);
				glVertex2f (x - 4.0, y - 10.0);
				glVertex2f (x - 2.0, y - 6.0);
				glVertex2f (x, y - 10.0);
				glVertex2f (x + 2.0, y - 6.0);
				glVertex2f (x + 4.0, y - 10.0);
				glVertex2f (x + 6.0, y - 6.0);
				glEnd ();
				glBegin (GL_LINE_STRIP);
				glVertex2f (x, y - 10.0);
				break;
			case -3:	//Direction is equal to -3 (Transformer is drawn towards right)
				glVertex2f (x + 4.0, y + 6.0);
				glVertex2f (x, y + 4.0);
				glVertex2f (x + 4.0, y + 2.0);
				glVertex2f (x, y);
				glVertex2f (x + 4.0, y - 2.0);
				glVertex2f (x, y - 4.0);
				glVertex2f (x + 4.0, y - 6.0);
				glEnd ();
				glBegin (GL_LINE_STRIP);
				glVertex2f (x + 6.0, y + 6.0);
				glVertex2f (x + 10.0, y + 4.0);
				glVertex2f (x + 6.0, y + 2.0);
				glVertex2f (x + 10.0, y);
				glVertex2f (x + 6.0, y - 2.0);
				glVertex2f (x + 10.0, y - 4.0);
				glVertex2f (x + 6.0, y - 6.0);
				glEnd ();
				glBegin (GL_LINE_STRIP);
				glVertex2f (x + 10.0, y);
				break;
			case -4:	//Direction is equal to -4 (Transformer is drawn towards left)
				glVertex2f (x - 4.0, y + 6.0);
				glVertex2f (x, y + 4.0);
				glVertex2f (x - 4.0, y + 2.0);
				glVertex2f (x, y);
				glVertex2f (x - 4.0, y - 2.0);
				glVertex2f (x, y - 4.0);
				glVertex2f (x - 4.0, y - 6.0);
				glEnd ();
				glBegin (GL_LINE_STRIP);
				glVertex2f (x - 6.0, y + 6.0);
				glVertex2f (x - 10.0, y + 4.0);
				glVertex2f (x - 6.0, y + 2.0);
				glVertex2f (x - 10.0, y);
				glVertex2f (x - 6.0, y - 2.0);
				glVertex2f (x - 10.0, y - 4.0);
				glVertex2f (x - 6.0, y - 6.0);
				glEnd ();
				glBegin (GL_LINE_STRIP);
				glVertex2f (x - 10.0, y);
				break;
			}
		}
	}
	glEnd ();
}

void DrawTransmissionLine(GBRANCH *agbranch)
{
	int j;
	glBegin (GL_LINE_STRIP);
	for (j = 0; j < agbranch->no_points * 2; j += 2)
	{
		glVertex2f (agbranch->pts_coords[j], agbranch->pts_coords[j + 1]);
	}
	glEnd ();
	
	   //glBegin (GL_POINTS);
	//glVertex2f(0,0);
	//glVertex2f(-0,-14.0000-1000);
	
	//glVertex2f(100,100);
	//glEnd();
}


/*PGconn DBConnect()
{
	PGconn *pgconn = NULL;
	
	
	
	return pgconn;
}*/


GLuint LoadLineObj(char *tablename)
{
    PGconn     *pgconn = NULL;
	PGresult   *res = NULL, *res2 = NULL;
	GLuint LinesID;	
	wxString s;
	char     *geotype=NULL, *data=NULL;
	char query[180];//,  geotype[100];
	GeoLines **Lines1, Lines;
	int i,j, numpointsmax, lastpos=0, parent=0, bits=0,col=0;
	float minx=9999999, miny=9999999, maxx=-999999, maxy=-999999;
	
	
	//conexão
	
	//s.Printf(wxT("Please enter password for %s@%s"), wxT(DB_USER), wxT(DB_SERVER));
	
	
	
	//fprintf(stderr, "%s", pass.ToAscii());
	
	
	pgconn = PQsetdbLogin(host.ToAscii(), DB_SERVER_PORT, NULL, NULL, db.ToAscii(), user.ToAscii(), pass.ToAscii());
						  //(wxGetPasswordFromUser(s, wxT("PostgreSQL Authentication"))).ToAscii());
	
	if (PQstatus(pgconn) == CONNECTION_BAD) 
	{
		fprintf(stderr, "ERROR CONNECTING TO DB!!!\n");
		PQfinish(pgconn);
		exit(0);
	}
	else
		fprintf(stdout, "CONNECTED TO DB.\n");
	
	/*
	//sprintf(query, "SELECT NumPoints(the_geom) FROM %s Order by numpoints desc",tablename); //dbtable.ToAscii()); 
	sprintf(query, "SELECT NumPoints(ExteriorRing(geometryN(the_geom,1))) FROM %s Order by numpoints desc",tablename); //dbtable.ToAscii()); 
	res = PQexec(pgconn, query);//"SELECT NumPoints(the_geom) FROM public Order by numpoints desc");
	
	numpointsmax = atoi(PQgetvalue(res, 0, 0));
	
	PQclear(res);
	
	//sprintf(query, "SELECT NumPoints(the_geom) FROM %s", tablename);//dbtable.ToAscii()); 
	sprintf(query, "SELECT NumPoints(ExteriorRing(geometryN(the_geom,1))) FROM %s", tablename);
	res = PQexec(pgconn, query);//"SELECT NumPoints(the_geom) FROM public");
	
	if (!res || PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		fprintf(stderr, "DECLARE CURSOR command failed (1)\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(1);
	}
	
	//Matriz de Linhas para acessar menos vezes o banco de dados
	//ja que os valores sao retornados por colunas e o desenho eh por linhas

	Lines1 = (GeoLines **)malloc(sizeof(GeoLines *)*PQntuples(res));
	
	//Pontos que formam as linhas
	for (i = 0; i<PQntuples(res); i++)
	  (Lines1[i]) = (GeoLines *)malloc(sizeof(GeoLines)*(atoi(PQgetvalue(res, i, 0)))); 
	
	
	//leitura das linhas
	
	for (j = 1; j < numpointsmax+1; j++)
	{
		
	    if (res2) PQclear(res2);
			
		//sprintf(query, "SELECT x(PointN(the_geom,%d)), y(PointN(the_geom,%d)) FROM %s", j, j, tablename);//dbtable.ToAscii()); 
	    
		sprintf(query, "SELECT x(PointN(ExteriorRing(geometryN(the_geom,1)),%d)), y(PointN(ExteriorRing(geometryN(the_geom,1)),%d)) FROM %s", j, j, tablename);
		res2 = PQexec(pgconn, query); 
		
		if (res2 && PQresultStatus(res2) == PGRES_TUPLES_OK )
		{			
			for (i = 0; i<PQntuples(res); i++)
			{
				if (!PQgetisnull(res2, i, 0)) //verifica se o ponto existe
				{
					
					if (Lines1[i][j-1].x > maxx) maxx = Lines1[i][j-1].x;
                    
                    if (Lines1[i][j-1].x < minx) minx = Lines1[i][j-1].x;	
					
					if (Lines1[i][j-1].y > maxy) maxy = Lines1[i][j-1].x;
                    
                    if (Lines1[i][j-1].y < miny) miny = Lines1[i][j-1].x;						
						
					Lines1[i][j-1].x = atof(PQgetvalue(res2, i, 0));
					Lines1[i][j-1].y = atof(PQgetvalue(res2, i, 1));
					//fprintf(stderr, "%f | %f\n",Lines1[i][j-1].x, Lines1[i][j-1].y);
					//if (Lines1[i][j-1].x > - 1) fprintf(stderr, "---------------%d %d \n",i, j);
											
				}				
			}
		}
	}
   */
	sprintf(query, "SELECT astext(the_geom) FROM %s", tablename);//dbtable.ToAscii()); 
	res = PQexec(pgconn, query);
	
	if (!res || PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		fprintf(stderr, "Query Error\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(1);
	}
	
	//Lines = (GeoLines *)malloc(sizeof(GeoLines)*(atoi(PQntuples(res)))); 
	
	LinesID = glGenLists(1);
    glNewList(LinesID, GL_COMPILE);
   
	
	
	//parser de dados
	for (i=0; i< PQntuples(res); i++)
	{
	 
	 
	 for (j=0 ; j < strlen(PQgetvalue(res,i,0)); j++)
	 {
		 if (PQgetvalue(res,i,0)[j] == '(')
		 {
			 parent++;
			 lastpos = j +1;
			 //fprintf(stderr, "%s \n",PQgetvalue(res,i,0));
			 if ((geotype) && (PQgetvalue(res,i,0)[j+1] != '('))
			 {
			   
				 if ((!strcmp(geotype, "MULTIPOLYGON")) || (!strcmp(geotype, "POLYGON")))
				 {
					 glBegin(GL_LINE_LOOP);
					 //fprintf(stderr, "lala");
				 }
			   
			   if ((!strcmp(geotype, "MULTILINESTRING")) || (!strcmp(geotype, "LINESTRING")))
				   glBegin(GL_LINE_STRIP); 
               
			   if ((!strcmp(geotype, "MULTIPOINT")) || (!strcmp(geotype, "POINT")))
				    glBegin(GL_POINTS);
			   
				//verificar!!!! erro!!!			 
			   //free(geotype);
			 
		      }
			  else if (geotype ==NULL)
              {			  
			 
				 geotype = (char *) malloc(sizeof(char)*(j+1));
			     strncpy(geotype, PQgetvalue(res,i,0), j);
				 geotype[j]=0;
				  //fprintf(stderr, "%d %s \n",j, geotype);
			  }
		 }
		 
		 //um glEnd somente
		 if ((PQgetvalue(res,i,0)[j] == ')') && (PQgetvalue(res,i,0)[j+1] != ')'))
			 glEnd();
		 
		 //para o switch
		// bits = (PQGetValue(res,i,0)[j] == ' ') + 2*(PQGetValue(res,i,0)[j] == ',');
		 
		 
		 //switch (bits)
		 //{
		//	 case 
		 
		 if (PQgetvalue(res,i,0)[j] == ' ')
		 {
			 //copia a coordenada X para data
			 data = (char *) malloc(sizeof(char)*(j- lastpos+1));
			 strncpy(data, PQgetvalue(res,i,0) + lastpos , j - lastpos); 
			 
			 lastpos = j +1;
			 data[j - lastpos] = 0;	
             //fprintf(stderr, "ok data %s| ", data);			 
			 Lines.x = atof(data);
			 free(data);
			 data = NULL;
			 //fprintf(stderr, "ok x %f| ", Lines.x);
		 }
		 
		 if ((PQgetvalue(res,i,0)[j] == ',') || (PQgetvalue(res,i,0)[j] == ')'))
		 {
			 data = (char *) malloc(sizeof(char)*(j- lastpos+1));
			 strncpy(data, PQgetvalue(res,i,0) + lastpos , j - lastpos); 
			 
			 lastpos = j +1;
			
			 data[j - lastpos] = 0;	 			 
			 //fprintf(stderr, "ok data %s| ", data);
			 
			 Lines.y = atof(data);
			 free(data);
			 data = NULL;
			 
			 
			 col++;
			 if (!col%300) fprintf(stderr," %d ... ", col);
			 
			 glVertex2f(Lines.x,Lines.y);
			 //fprintf(stderr, "ok y %f ", Lines.y);
			 
			 if (PQgetvalue(res,i,0)[j] == ')')
			 {
			   glEnd();
			   if (PQgetvalue(res,i,0)[j+1] != '(')
				   break;
		     }
			 
		 }
		 
		 
	 }
	 
 }
		 
		 
	glEndList();	 
		 
	/*
	
	LinesID = glGenLists(1);
    glNewList(LinesID, GL_COMPILE);
   
	//glTranslatef(90, 50, 0);

   for (i = 0; i < PQntuples(res); i++)
   {
	   glBegin(GL_LINE_STRIP);
	   for (j=0; j< atoi(PQgetvalue(res, i, 0)); j++)
	   {
		   glVertex2f(Lines1[i][j].x, Lines1[i][j].y);
		   
		   if (!Lines1[i][j].x)
					{
				   fprintf(stderr, "%f | %f\n",Lines1[i][j-1].x, Lines1[i][j-1].y);
					fprintf(stderr, "---------------\n");
					   fprintf(stderr, "%d | %d\n", i, j);
						
					}
		  
	   }
	   glEnd();
	   
   }
   
    glEndList();
   
   
   for (i = 0; i<PQntuples(res); i++)
	  free(Lines1[i]);
	
	free (Lines1);*/
	
	PQclear(res);
	//fprintf(stderr, "fim");	
   
    //if (res2) PQclear(res2);
	
	PQfinish(pgconn);
	 
	
	
	return LinesID;
}




/*
void DrawBus1(int busnumber, GBUS *agbus, bool alternate, GLfloat zf, int info)
{
    int j;
    char number[3];
    
    glLineWidth(3.0);
    glPointSize(2.5);
    glColor3f(bus_color[0], bus_color[1], bus_color[2]);
    
    j = busnumber;
    gcvt(j, 3, number);
    
    if ((agbus->xi == agbus->xf) && (agbus->yi == agbus->yf)) 
	{  
		glEnable(GL_POINT_SMOOTH);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);
		glBegin(GL_POINTS);
		glVertex2f(agbus->xi, agbus->yi);
		glEnd();
		glDisable(GL_POINT_SMOOTH);
    }
    else 
	{
		glBegin(GL_LINES);
		glVertex2f(agbus->xi, agbus->yi);
		glVertex2f(agbus->xf, agbus->yf);
		glEnd();
    }
    if (info) 
	{
		glColor3f(text_color[0], text_color[1], text_color[2]);
		DRAWTEXT(agbus->xi-5.0/zf, agbus->yi-2, number, font10);
		glColor3f(bus_color[0], bus_color[1], bus_color[2]);
    }
    
    glLineWidth(1.0);
    glPointSize(1.0);
}
*/

bool IsWithin(GLfloat * vis_win, GLfloat * coords, GLint no_points)
{
	
	/*printf("C: %f %f %f %f \n", coords[0], coords[1], coords[2], coords[3]);
	printf("V: %f %f %f %f \n", vis_win[0], vis_win[1], vis_win[2], vis_win[3]);
*/
	return 
	(
	(((coords[0] >= vis_win[0]) && (coords[1] >= vis_win[1])) &&
     ((coords[0] <= vis_win[2]) && (coords[1] <= vis_win[3])))
    || 
    (((coords[2 * no_points - 2] >= vis_win[0]) && (coords[2 * no_points - 1] >= vis_win[1])) &&
     ((coords[2 * no_points - 2] <= vis_win[2]) && (coords[2 * no_points - 1] <= vis_win[3])))
	);//*/ return true;

}

GLfloat* GetVisibleArea(void) 
{
    GLint viewport[4]; //viewport[0]=x ; viewport[1]=y ; viewport[2]=width ; viewport[3]=height
    GLdouble mvmatrix[16], projmatrix[16];
    GLdouble wx, wy, wz; /* returned world x, y, z coords */
    GLdouble wxf, wyf, wzf; /* returned world x, y, z coords */
    GLfloat *visible_coords; // visible_coords = (xi_world, yi_world, xf_world, yf_world)
    
    glGetIntegerv (GL_VIEWPORT, viewport);
    glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
    glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);
    
    gluUnProject(0.0, 0.0, 0.0, mvmatrix, projmatrix, viewport, &wx, &wy, &wz);
    gluUnProject(viewport[2], viewport[3], 0.0, mvmatrix, projmatrix, viewport, &wxf, &wyf, &wzf);
    
	visible_coords = new GLfloat[4];
    visible_coords[0] = (GLfloat)wx;
    visible_coords[1] = (GLfloat)wy;
    visible_coords[2] = (GLfloat)wxf;
    visible_coords[3] = (GLfloat)wyf;

    return visible_coords;
}
