#ifndef VPAUX_H
#define VPAUX_H

#include <wx/glcanvas.h>
#include "vpDefs.h"
#include "FTGL/FTGLPixmapFont.h"
#include <libpq-fe.h>
#include <wx/textdlg.h>
//#include "FTGL/FTGLTextureFont.h"


void DrawCircunference(double r, double x, double y, int fill);
void DrawPieChart(GLfloat center_x, GLfloat center_y, GLfloat radius, GLfloat color_1, GLfloat color_2, GLfloat color_3, GLfloat percentage, GLint num_points);
void DrawGenerator(GLint dir, GLfloat x, GLfloat y/*, char *gen_MW, char *gen_MVAR*/);
void DrawLoad(GLint dir, GLfloat x, GLfloat y);
void DrawSusceptance(GLint dir, GLfloat x, GLfloat y);
void DrawBusGenerator(BUS *abus, GBUS *agbus);

void DrawBusLoad(GLfloat busloadmw, GBUS *agbus);
void DrawBusSusceptance(GLfloat bussusc, GBUS *agbus);
void DrawBus(int busnumber, GBUS *agbus, bool alternate, GLfloat zf, int info);
void DrawTransformer(GBRANCH *agbranch);
void DrawTransmissionLine(GBRANCH *agbranch);

void DrawEletricalPoint(void);
GLuint LoadLineObj(char *tablename);
PGconn DBConnect();

bool IsWithin(GLfloat * vis_win, GLfloat * coords, GLint no_points);
GLfloat* GetVisibleArea(void);

#define DRAWTEXT(ax, ay, as, afont)\
{\
	{\
		glRasterPos2f(ax, ay);\
		afont->Render(as);\
	}\
}

#define DRAWTEXTV(ax, ay, as, afont, bh)\
{\
	{\
		int _i;\
		char ts[2]={0,0};\
		for (_i=0; _i < strlen(as); _i++)\
		{\
			glRasterPos2f(ax, ay - _i * bh * afont->FaceSize());\
			ts[0] = as[_i];\
			afont->Render(ts);\
		}\
	}\
}


#endif //VPAUX_H
