#include "vpSim.h"
//#include "meschach/matrix.h"
//#include "meschach/matrix2.h"
#define NDEBUG
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/matrix_proxy.hpp>

extern int horario;
extern BUS bus[BUS_NUM];
extern GLint bus_num;
extern GLint branch_num;

GLuint teste;

wxString user;
wxString pass;
wxString db;
wxString dbtable;
wxString host;

//mod
float *EPointsCoord;

//GeoData *EPointsCoord2;

GeoLines **Lines1;
GLuint FirstLines=0;
GLuint Mapa=0;
GLuint Hidro=0;

BRANCH branch[BRANCH_NUM];
BUS_DSP bus_dsp[BUS_NUM];
BRANCH_DSP branch_dsp[BRANCH_NUM];
BUS bus[BUS_NUM];
GBUS Gbus[BUS_NUM];
GBRANCH Gbranch[BRANCH_NUM];

extern GLfloat max_demanda_L, max_carregamento, maior_max_pot;
extern int timeframe; 

//Demanda Total de Carga, a cada hora
GLfloat demanda_L[TIMEFRAME] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
//Carregamento Total das Linhas, a cada hora
GLfloat carregamento[TIMEFRAME] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
//Percentagem maxima do carregamento das linhas, a cada hora
GLfloat carregamento_perc[TIMEFRAME] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
//Percentagem maxima de carregamento (individual) de uma linha, a cada hora
GLfloat max_carregamento_perc[TIMEFRAME] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};

// #include <iostream>
// #include <fstream>
 //#include <vector>

	

namespace ublas = boost::numeric::ublas;
	
// from: http://www.crystalclearsoftware.com/cgi-bin/boost_wiki/wiki.pl?Effective_UBLAS/Matrix_Inversion
 /**
  * Invert a matrix via gauss-jordan algorithm (PARTIAL PIVOT)
  *
  * @param m The matrix to invert. Must be square.
  * @param singular If the matrix was found to be singular, then this
  *        is set to true, else set to false.
  * @return If singular is false, then the inverted matrix is returned.
  *         Otherwise it contains random values.
  */
 
	template<class T>
 //#define T double /// for debug
 boost::numeric::ublas::matrix<T>
 gjinverse(const boost::numeric::ublas::matrix<T> &m, 
           bool &singular)
 {
     using namespace boost::numeric::ublas;

     const int size = m.size1();

     // Cannot invert if non-square matrix or 0x0 matrix.
     // Report it as singular in these cases, and return 
     // a 0x0 matrix.
     if (size != m.size2() || size == 0)
     {
         singular = true;
         matrix<T> A(0,0);
         return A;
     }

     // Handle 1x1 matrix edge case as general purpose 
     // inverter below requires 2x2 to function properly.
     if (size == 1)
     {
         matrix<T> A(1, 1);
         if (m(0,0) == 0.0)
         {
             singular = true;
             return A;
         }
         singular = false;
         A(0,0) = 1/m(0,0);
         return A;
     }

     // Create an augmented matrix A to invert. Assign the
     // matrix to be inverted to the left hand side and an
     // identity matrix to the right hand side.
     matrix<T> A(size, 2*size);
     matrix_range<matrix<T> > Aleft(A, 
                                    range(0, size), 
                                    range(0, size));
     Aleft = m;
     matrix_range<matrix<T> > Aright(A, 
                                     range(0, size), 
                                     range(size, 2*size));
     Aright = identity_matrix<T>(size);

     // Swap rows to eliminate zero diagonal elements.
     for (int k = 0; k < size; k++)
     {
         if ( A(k,k) == 0 ) // XXX: test for "small" instead
         {
             // Find a row(l) to swap with row(k)
             int l = -1;
             for (int i = k+1; i < size; i++) 
             {
                 if ( A(i,k) != 0 )
                 {
                     l = i; 
                     break;
                 }
             }

             // Swap the rows if found
             if ( l < 0 ) 
             {
                 std::cerr << "Error:" <<  __FUNCTION__ << ":"
                           << "Input matrix is singular, because cannot find"
                           << " a row to swap while eliminating zero-diagonal.";
                 singular = true;
                 return Aleft;
             }
             else 
             {
                 matrix_row<matrix<T> > rowk(A, k);
                 matrix_row<matrix<T> > rowl(A, l);
                 rowk.swap(rowl);

 #if defined(DEBUG) || !defined(NDEBUG)
                 std::cerr << __FUNCTION__ << ":"
                           << "Swapped row " << k << " with row " << l 
                           << ":" << A << "\n";
 #endif
             }
         }
     }

     // Doing partial pivot
     for (int k = 0; k < size; k++)
     {
         // normalize the current row
         for (int j = k+1; j < 2*size; j++)
             A(k,j) /= A(k,k);
         A(k,k) = 1;

         // normalize other rows
         for (int i = 0; i < size; i++)
         {
             if ( i != k )  // other rows  // FIX: PROBLEM HERE
             {
                 if ( A(i,k) != 0 )
                 {
                     for (int j = k+1; j < 2*size; j++)
                         A(i,j) -= A(k,j) * A(i,k);
                     A(i,k) = 0;
                 }
             }
         }

 #if defined(DEBUG) || !defined(NDEBUG)
         std::cerr << __FUNCTION__ << ":"
                   << "GJ row " << k << " : " << A << "\n";
 #endif
     }

     singular = false;
     return Aright;
 }

  
/*=============================================*/
/*  FUNCTION FOR ACTIVE POWER MATRIX HANDLING  */
/*=============================================*/
void vpSimulator(void) //simulator
{ 
	using namespace boost::numeric::ublas;
	matrix<double> 	B(bus_num, bus_num), Pot_bus(bus_num, 1), 
					delta(bus_num, 1), B_inv(bus_num, bus_num);
	bool singular;
	
//Matriz Unidimensional de Potencia Ativa Total dos Barramentos (Pot = Pgeracao - Pcarga)
//e matriz B (bus_num X bus_num)
//	MAT *B, *Pot_bus, *delta;
//	MAT *B_inv;
	int i,j;
/*
	Pot_bus = m_get(bus_num, 1);
	B = m_get(bus_num, bus_num);
	delta = m_get(bus_num, 1);
	B_inv = m_get(bus_num, bus_num);
*/
	// Initialize the matrix B and Pot_bus with zeros 
	Pot_bus.clear();
	B.clear();

/*	m_zero(Pot_bus);	// Pot_bus *= 0.0;
	m_zero(B);			// B *= 0.0;
*/
	// Builds the Pot_bus matrix
	for (i=0; i<bus_num; i++)
	{
		Pot_bus(i, 0) = bus_dsp[i].pot_G[horario] - bus_dsp[i].pot_L[horario];
	}

//    printf("===MATRIX POT_BUS===\n");
//    m_output(Pot_bus);

	// Builds the B matrix
	for (i=0; i<branch_num; i++)
	{
		B(branch[i].tap_bus-1, branch[i].z_bus-1) = -(1.0/branch[i].reactance);
		B(branch[i].z_bus-1, branch[i].tap_bus-1) = -(1.0/branch[i].reactance);
	}

	for (i=0; i<bus_num; i++) 
	{
		for (j=0; j<bus_num; j++) 
		{
			if (i != j) 
			{
				B(i, i) -= B(i,j);
			}
		}
	}

	// Approximation made: B[0][0] = 1.0e+6
	B(0, 0) = 1.0e+6;

//    printf("===MATRIX B===\n");
//    m_output(B);
	//Inverts the B matrix
	//m_inverse(B, B_inv);
//	fprintf(stdout, "Inverting matrix B...");
	noalias(B_inv) = gjinverse(B, singular);
	//InvertMatrix(B, B_inv);
	if (singular)
	{
		fprintf(stderr, "ERROR: Matrix B is singular!\n");
		return;
	}
//	fprintf(stdout, "Done \n");
//    printf("===MATRIX B_inv===\n");
//    m_output(B_inv);

	//Finds the delta matrix by multiplying the inverse of B and Pot
	//m_mlt(B_inv, Pot_bus, delta);
	noalias(delta) = prod(B_inv, Pot_bus);
	
	
//	printf("===MATRIX DELTA===\n");
//	m_output(delta);

	for(i=0; i<branch_num; i++)
	{
		if(delta(branch[i].tap_bus-1, 0) > delta(branch[i].z_bus-1, 0))
		{
			branch_dsp[i].pot[horario] = (delta(branch[i].tap_bus-1, 0) - delta(branch[i].z_bus-1, 0))/branch[i].reactance;
		}
		else
		{
			branch_dsp[i].pot[horario] = (delta(branch[i].z_bus-1, 0) - delta(branch[i].tap_bus-1, 0))/branch[i].reactance;
		}
	}

	carregamento[horario] = 0.0;
	carregamento_perc[horario] = 0.0;
	max_carregamento_perc[horario] = 0.0;

	//Forma o vetor com os carregamentos totais das linhas em cada horario (valores absoluto e percentagens)
	for (i=0; i<branch_num; i++)
	{
		if (branch_dsp[i].max_pot != 0.0) 
		{//   if (((branch_dsp[i].pot[horario]/branch_dsp[i].max_pot)*100.0) < 100.0)
			branch_dsp[i].pot_perc[horario] = (branch_dsp[i].pot[horario]/branch_dsp[i].max_pot)*100.0;
		}
		else
		{
			branch_dsp[i].pot_perc[horario] = 0.0;
		}
		carregamento[horario] += branch_dsp[i].pot[horario];
		carregamento_perc[horario] += branch_dsp[i].pot_perc[horario];

		if (branch_dsp[i].pot_perc[horario]>max_carregamento_perc[horario]) 
		{
			max_carregamento_perc[horario]=branch_dsp[i].pot_perc[horario];
			//printf("||||max = %f, BRANCH %i at %i oclock  -----  %f || %f\n", max_carregamento_perc[horario], i, horario, branch_dsp[i].pot[horario], branch_dsp[i].max_pot);
		}
	}

	//Calculo do carregamento percentual medio na hora
	carregamento_perc[horario] = carregamento_perc[horario]/branch_num;

	//Estabelece a maior dos carregamentos horarios, em valores absolutos e percentagens (para auxiliar na constru�o do grafico)
	max_carregamento = carregamento[0];
	for (i=0; i<24; i++)
	{
		if (carregamento[i]>max_carregamento) max_carregamento=carregamento[i];
	}

//        printf("Potencias(MW) nos branches as %i horas:\n", horario);
//        for(i=0; i<branch_num; i++){
//     printf("%f\n", branch_dsp[i].pot_perc[horario]);
//        }

//for (i=0; i<24; i++){
//  printf("%f\n", max_carregamento_perc[i]);
//}
/*	M_FREE(B);
	M_FREE(Pot_bus);
	M_FREE(B_inv);
	M_FREE(delta);
*/

}

void vpRead_Uhe_geo(void)
{
  	PGconn     *pgconn = NULL;
	PGresult   *res = NULL, *res2 = NULL;
	//float *_EPointsCoord;
	float **LinesMatrix;
	wxString s;
	char query[80];
	int i,j, numpointsmax;
	
	//EPointsCoord2 = (GeoData *) malloc(sizeof(GeoData));
	
	//s.Printf(wxT("Please enter password for %s@%s"), wxT(DB_USER), wxT(DB_SERVER));
	
	//pgconn = PQsetdbLogin(DB_SERVER, DB_SERVER_PORT, NULL, NULL, "vp", DB_USER,
	//					  (wxGetPasswordFromUser(s, wxT("PostgreSQL Authentication"))).ToAscii());
	
	if (PQstatus(pgconn) == CONNECTION_BAD) 
	{
		fprintf(stderr, "ERROR CONNECTING TO DB!!!\n");
		PQfinish(pgconn);
		exit(0);
	}
	else
		fprintf(stdout, "CONNECTED TO DB.\n");

	
	res = PQexec(pgconn, "BEGIN");
	if (!res || PQresultStatus(res) != PGRES_COMMAND_OK)
	{
		fprintf(stderr, "BEGIN command failed\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(0);
	}

	PQclear(res);

	
	res = PQexec(pgconn, "DECLARE cursor CURSOR FOR SELECT x(the_geom),y(the_geom) FROM uhe_geo");
	
	
	
	if (!res || PQresultStatus(res) != PGRES_COMMAND_OK)
	{
		fprintf(stderr, "DECLARE CURSOR command failed (1)\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(1);
	}
	PQclear(res);
	
	
	res = PQexec(pgconn, "FETCH ALL in cursor");
	
	
	
	if (!res || PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		fprintf(stderr, "FETCH ALL command didn't return tuples properly\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(1);
	}
	
	
	/*FirstLines = 999;
	Mapa = 999;*/
	//O primeiro elemento guardará o tamanho do vetor, provisório!
	EPointsCoord = (float *)malloc((2*PQntuples(res) + 1)*sizeof(float));
	
    /*EPointsCoord2->xcoords = (float *)malloc((PQntuples(res) + 1)*sizeof(float));
	EPointsCoord2->ycoords = (float *)malloc((PQntuples(res) + 1)*sizeof(float));
    
    EPointsCoord2->xcoordmax = - 9999999;	//implementar com menor numero possivel -2³² por exemplo
	EPointsCoord2->ycoordmax = - 9999999;
	
	EPointsCoord2->ycoordmin = 999999;
	EPointsCoord2->xcoordmin = 999999;
	
	
	EPointsCoord[0] = PQntuples(res);
	
	EPointsCoord2->numofpoints = PQntuples(res);
	j=1;
	for (i=1 ; i< PQntuples(res); i+=1)
	{
	  //x
	  //EPointsCoord[i]=atof (PQgetvalue(res, i, 0));
	  EPointsCoord2->xcoords[i] = atof (PQgetvalue(res, i, 0));
	  
	  if ( EPointsCoord2->xcoords[i] < EPointsCoord2->xcoordmin)
		  EPointsCoord2->xcoordmin = EPointsCoord2->xcoords[i];
	  
	  if ( EPointsCoord2->xcoords[i] > EPointsCoord2->xcoordmax)
		  EPointsCoord2->xcoordmax = EPointsCoord2->xcoords[i];

		
	  //y
	  //EPointsCoord[i+1]=atof (PQgetvalue(res, i, 1));

	  EPointsCoord2->ycoords[i] = atof (PQgetvalue(res, i, 1));
	  
	  if ( EPointsCoord2->ycoords[i] < EPointsCoord2->ycoordmin)
		  EPointsCoord2->ycoordmin = EPointsCoord2->ycoords[i];
	  
	  if ( EPointsCoord2->ycoords[i] > EPointsCoord2->ycoordmax)
		  EPointsCoord2->ycoordmax = EPointsCoord2->ycoords[i];	  
		
	}*/
	
	
	//SELECT X(StartPoint(GeometryN(the_geom,1))) FROM public;
		
	
	//res = PQexec(pgconn, "DECLARE cursor CURSOR FOR SELECT X(StartPoint(GeometryN(the_geom,1))) FROM public");
	
	//incrementa-se o 1 no argumento de geometryN e acessa-se as outras coordenadas
	// NumGeometries(geometry)

    //If geometry is a GEOMETRYCOLLECTION (or MULTI*) return the number of geometries, otherwise return NULL.
	
	
	//quanto a proj, basta usar Transform(geometry,integer), mas qual o SRID?
	//=======================================
	//problema: SRID cartesiano (qual eh?)
	//TODO: importar Multilinestring usando startpoint, 
	//endpoint, GeometryN e NumGeometries
	//=======================================
	
	
	/*if (!res || PQresultStatus(res) != PGRES_COMMAND_OK)
	{
		fprintf(stderr, "DECLARE CURSOR command failed (1)\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(1);
	}
	PQclear(res);
	
	
	res = PQexec(pgconn, "FETCH ALL in cursor");*/

	PQfinish(pgconn);
	
}

void vpReadData()
{
	PGconn     *pgconn = NULL;
	PGresult   *res = NULL, *res2 = NULL;
//	char *query;
	int i, t, r;
//	int nFields;
	int u;
	wxString s;
	
	
	/*FirstLines = 999;
	Mapa = 999;*/
	
	s.Printf(wxT("Please enter database host"));	
	host.Printf(wxGetTextFromUser(s, wxT("PostgreSQL Authentication")));
	
	s.Printf(wxT("Please enter database name @%s"), host.ToAscii());	
	db.Printf(wxGetTextFromUser(s, wxT("PostgreSQL Authentication")));
	
	s.Printf(wxT("Please enter user login@%s"), host.ToAscii());
	user.Printf(wxGetTextFromUser(s, wxT("PostgreSQL Authentication")));
	
	s.Printf(wxT("Please enter password for %s@%s"), user.ToAscii(), host.ToAscii());
	pass.Printf(wxGetPasswordFromUser(s, wxT("PostgreSQL Authentication")));
	
	
	
	//dbtable = wxT("mesoregioes");
	
	
	pgconn = PQsetdbLogin(host.ToAscii(), DB_SERVER_PORT, NULL, NULL, db.ToAscii(), user.ToAscii(), pass.ToAscii());
						  //(wxGetPasswordFromUser(s, wxT("PostgreSQL Authentication"))).ToAscii());
	if (PQstatus(pgconn) == CONNECTION_BAD) 
	{
		fprintf(stderr, "ERROR CONNECTING TO DB!!!\n");
		PQfinish(pgconn);
		exit(0);
	}
	else
		fprintf(stdout, "CONNECTED TO DB.\n");

	// start a transaction block 
	res = PQexec(pgconn, "BEGIN");
	if (!res || PQresultStatus(res) != PGRES_COMMAND_OK)
	{
		fprintf(stderr, "BEGIN command failed\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(0);
	}

	PQclear(res);

/////////////////////////BUS DATA SECTION
	res = PQexec(pgconn, "DECLARE mycursor CURSOR FOR SELECT * FROM BUS_176");
	
	//res = PQexec(pgconn, "DECLARE cursorx CURSOR FOR SELECT x(the_geom) FROM uhe_geo");
	//res = PQexec(pgconn, "DECLARE cursory CURSOR FOR SELECT y(the_geom) FROM uhe_geo");
	
	
	if (!res || PQresultStatus(res) != PGRES_COMMAND_OK)
	{
		fprintf(stderr, "DECLARE CURSOR command failed (1)\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(1);
	}
	PQclear(res);
	res = PQexec(pgconn, "FETCH ALL in mycursor");
	
	//res = PQexec(pgconn, "FETCH ALL in cursorx");
	//res2 = PQexec(pgconn, "FETCH ALL in cursory");
	
	
	if (!res || PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		fprintf(stderr, "FETCH ALL command didn't return tuples properly\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(1);
	}
	
	
    for (i=0 ; i< PQntuples(res); i++)
	{
	
		
	}
		/*nFields = PQnfields(res);
	for (i = 0; i < nFields; i++)
	printf("%d = %s ", i, PQfname(res, i));
	printf("\n\n");*/
//	res = mysql_use_result (mysql);

	r = 0;
	for (i = 0; i < PQntuples(res); i++)
	{
		//IEEE Electrical Information 
		bus[r].number = atoi (PQgetvalue(res, i, 0));//row[0]);
//		for (t = 0; t <= strlen (row[1]); t++)
//		{
		bus[r].name[0] = 0; //row[1][t];
//		}

		bus[r].load_flow_area = atoi (PQgetvalue(res, i, 2));//row[2]);
		bus[r].loss_zone = atoi (PQgetvalue(res, i, 3));//row[3]);
		bus[r].type = atoi (PQgetvalue(res, i, 4));//row[4]);
		bus[r].voltage = atof (PQgetvalue(res, i, 5));//row[5]);
		bus[r].angle = atof (PQgetvalue(res, i, 6));//row[6]);
		bus[r].load_MW = atof (PQgetvalue(res, i, 7));//row[7]);
		bus[r].load_MVAR = atof (PQgetvalue(res, i, 8));//row[8]);
		bus[r].gen_MW = atof (PQgetvalue(res, i, 9));//row[9]);
		bus[r].gen_MVAR = atof (PQgetvalue(res, i, 10));//row[10]);
		bus[r].base_KV = atof (PQgetvalue(res, i, 11));//row[11]);
		bus[r].des_volts = atof (PQgetvalue(res, i, 12));//row[12]);
		bus[r].max_voltage = atof (PQgetvalue(res, i, 13));//row[13]);
		bus[r].min_voltage = atof (PQgetvalue(res, i, 14));//row[14]);
		bus[r].conductance = atof (PQgetvalue(res, i, 15));//row[15]);
		bus[r].susceptance = atof (PQgetvalue(res, i, 16));//row[16]);
		bus[r].remote = atoi (PQgetvalue(res, i, 17));//row[17]);
		//Bus Dispatch Information
		t = 0;
		for (u = 9; u < 33; u++)
		{
			bus_dsp[r].pot_L[t] = atof (PQgetvalue(res, i, 2*u));//row[2 * u]);
			bus_dsp[r].pot_G[t] = atof (PQgetvalue(res, i, (2*u) + 1));////row[(2 * u) + 1]);
			t++;
		}
		//Bus Graphical Information
		Gbus[r].xi = atof (PQgetvalue(res, i, 66));////row[66]);
		Gbus[r].yi = atof (PQgetvalue(res, i, 67));//row[67]);
		Gbus[r].xf = atof (PQgetvalue(res, i, 68));//row[68]);
		Gbus[r].yf = atof (PQgetvalue(res, i, 69));//row[69]);
		Gbus[r].Gen_dir = atoi (PQgetvalue(res, i, 70));//row[70]);
		Gbus[r].Gen_x = atof (PQgetvalue(res, i, 71));//row[71]);
		Gbus[r].Gen_y = atof (PQgetvalue(res, i, 72));//row[72]);
		Gbus[r].Load_dir = atoi (PQgetvalue(res, i, 73));//row[73]);
		Gbus[r].Load_x = atof (PQgetvalue(res, i, 74));//row[74]);
		Gbus[r].Load_y = atof (PQgetvalue(res, i, 75));//row[75]);
		Gbus[r].Suscep_dir = atoi (PQgetvalue(res, i, 76));//row[76]);
		Gbus[r].Suscep_x = atof (PQgetvalue(res, i, 77));//row[77]);
		Gbus[r].Suscep_y = atof (PQgetvalue(res, i, 78));//row[78]);
		r++;
	}
	bus_num = r;
	printf ("%i BUSES, QUERY IS OK!\n", bus_num);

	PQclear(res);
	
	/* close the cursor */
	res = PQexec(pgconn, "CLOSE mycursor");
	PQclear(res);
	
	/* commit the transaction */
	res = PQexec(pgconn, "COMMIT");
	PQclear(res);




/////////////////////////BRANCH DATA SECTION
	// start a transaction block 
	res = PQexec(pgconn, "BEGIN");
	if (!res || PQresultStatus(res) != PGRES_COMMAND_OK)
	{
		fprintf(stderr, "BEGIN command failed (2) \n");
		PQclear(res);
		PQfinish(pgconn);
		exit(0);
	}
	PQclear(res);
	
	res = PQexec(pgconn, "DECLARE mycursor CURSOR FOR SELECT * FROM BRANCH_176");
	if (!res || PQresultStatus(res) != PGRES_COMMAND_OK)
	{
		fprintf(stderr, "DECLARE CURSOR command failed (2)\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(1);
	}

	PQclear(res);
	res = PQexec(pgconn, "FETCH ALL in mycursor");
	if (!res || PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		fprintf(stderr, "FETCH ALL command didn't return tuples properly (2)\n");
		PQclear(res);
		PQfinish(pgconn);
		exit(1);
	}
/*	
	nFields = PQnfields(res);
	for (i = 0; i < nFields; i++)
	printf("%d = %s\n", i, PQfname(res, i));
	printf("\n\n");
*/
	r = 0;
	for (i = 0; i < PQntuples(res); i++)
	{
		branch[r].tap_bus = atoi (PQgetvalue(res, i, 0));//row[0]);
		branch[r].z_bus = atoi (PQgetvalue(res, i, 1));//row[1]);
		branch[r].load_flow_area = atoi (PQgetvalue(res, i, 2));//row[2]);
		branch[r].loss_zone = atoi (PQgetvalue(res, i, 3));//row[3]);
		branch[r].circuit = atoi (PQgetvalue(res, i, 4));//row[4]);
		branch[r].type = atoi (PQgetvalue(res, i, 5));//row[5]);
		branch[r].resistance = atof (PQgetvalue(res, i, 6));//row[6]);
		branch[r].reactance = atof (PQgetvalue(res, i, 7));//row[7]);
		branch[r].charging = atof (PQgetvalue(res, i, 8));//row[8]);
		branch[r].MVA_1 = atoi (PQgetvalue(res, i, 9));//row[9]);
		branch[r].MVA_2 = atoi (PQgetvalue(res, i, 10));//row[10]);
		branch[r].MVA_3 = atoi (PQgetvalue(res, i, 11));//row[11]);
		branch[r].control_bus = atoi (PQgetvalue(res, i, 12));//row[12]);
		branch[r].side = atoi (PQgetvalue(res, i, 13));//row[13]);
		branch[r].turns_ratio = atof (PQgetvalue(res, i, 14));//row[14]);
		branch[r].angle = atof (PQgetvalue(res, i, 15));//row[15]);
		branch[r].min_tap = atof (PQgetvalue(res, i, 16));//row[16]);
		branch[r].max_tap = atof (PQgetvalue(res, i, 17));//row[17]);
		branch[r].step = atof (PQgetvalue(res, i, 18));//row[18]);
		branch[r].min_voltage = atof (PQgetvalue(res, i, 19));//row[19]);
		branch[r].max_voltage = atof (PQgetvalue(res, i, 20));//row[20]);
		//Branch Dispatch Information
		branch_dsp[r].max_pot = atof (PQgetvalue(res, i, 21));//row[21]);
		t = 0;
		for (u = 22; u < 46; u++)
		{
			branch_dsp[r].pot[t] = atof (PQgetvalue(res, i, u));//row[u + 1]);
			t++;
		}
		//Branch Graphical Information
		u = 46;
		t = 0;
		while (!PQgetisnull(res, i, u) && u < 67)//
		{
			Gbranch[r].pts_coords[t] = atof (PQgetvalue(res, i, u));//row[u]);
			u++;
			t++;
		}
		
		Gbranch[r].no_points = (u - 46) / 2;
		Gbranch[r].center[0] = atof (PQgetvalue(res, i, 66));//row[66]);
		Gbranch[r].center[1] = atof (PQgetvalue(res, i, 67));//row[67]);
		r++;
	}
	branch_num = r;
	printf ("%i BRANCHES, QUERY IS OK!\n", branch_num);

	PQclear(res);
	
	/* close the cursor */
	res = PQexec(pgconn, "CLOSE mycursor");
	PQclear(res);
	
	/* commit the transaction */
	res = PQexec(pgconn, "COMMIT");
	PQclear(res);
	
	//mysql_close (mysql);
	PQfinish(pgconn);

	vpUpdateVectors();
	
}

void vpUpdateVectors()
{
	int i, t;
	
	memset(demanda_L, 0, sizeof(demanda_L));
	memset(carregamento, 0, sizeof(carregamento));
	memset(carregamento_perc, 0, sizeof(carregamento_perc));
	memset(max_carregamento_perc, 0, sizeof(max_carregamento_perc));
	
	
	//Forma o vetor com as demandas totais de carga em cada horario
	for (i = 0; i < timeframe; i++)
	{
		for (t = 0; t < bus_num; t++)
		{
			demanda_L[i] += bus_dsp[t].pot_L[i];
		}
	}
		
	//Estabelece a maior das demandas horarias (para auxiliar na constru�o do grafico)
	max_demanda_L = demanda_L[0];
	for (i = 0; i < timeframe; i++)
	{
		if (demanda_L[i] > max_demanda_L)
			max_demanda_L = demanda_L[i];
	}
	
	maior_max_pot = branch_dsp[0].max_pot;
	//Forma o vetor com os carregamentos totais das linhas em cada horario (valores absoluto e percentagens)
	for (i = 0; i < timeframe; i++)
	{
		for (t = 0; t < branch_num; t++)
		{
			if (branch_dsp[t].max_pot != 0.0)
			{
				branch_dsp[t].pot_perc[i] =
						(branch_dsp[t].pot[i] /
						branch_dsp[t].max_pot) * 100.0;
			}
			else
			{
				branch_dsp[t].pot_perc[i] = 0.0;
			}
			carregamento[i] += branch_dsp[t].pot[i];
			carregamento_perc[i] += branch_dsp[t].pot_perc[i];
			if (branch_dsp[t].pot_perc[i] >
						 max_carregamento_perc[i])
			{
				max_carregamento_perc[i] =
						branch_dsp[t].pot_perc[i];
				//  if (i==0) {
				//      printf("max = %f, BRANCH %i at %i oclock  -----  %f || %f\n", max_carregamento_perc[i], t, i, branch_dsp[t].pot[i], branch_dsp[t].max_pot);
				//  }
			}
			if (branch_dsp[t].max_pot > maior_max_pot)
				maior_max_pot = branch_dsp[t].max_pot;
		}
	}
	//Calculo do carregamento percentual medio na hora
	for (i = 0; i < timeframe; i++)
	{
		carregamento_perc[i] = carregamento_perc[i] / branch_num;
	}
	//Estabelece a maior dos carregamentos horarios, em valores absolutos e percentagens (para auxiliar na constru�o do grafico)
	max_carregamento = carregamento[0];
	for (i = 0; i < timeframe; i++)
	{
		if (carregamento[i] > max_carregamento)
			max_carregamento = carregamento[i];
	}
}



void vpInitData()
{
	int i, j;

	for (i = 0; i < bus_num; i++)
	{
		for (j = 0; j < 24; j++)
		{

			if (j == 0)
			{
				//bus_dsp[i].pot_L[j] = 1.0*bus[i].load_MW;
				//bus_dsp[i].pot_G[j] = 1.0*bus[i].gen_MW ;
				bus_dsp[i].pot_L[j] = 0.33 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.37 * bus[i].gen_MW;
				//printf("BUS %i:\n pot_L0 = %f\n pot_G0 = %f\n", i, bus_dsp[i].pot_L[j], bus_dsp[i].pot_G[j]);
			}
			if (j == 1)
			{
				bus_dsp[i].pot_L[j] = 0.4 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.42 * bus[i].gen_MW;
			}
			if (j == 2)
			{
				bus_dsp[i].pot_L[j] = 0.35 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.4 * bus[i].gen_MW;
			}
			if (j == 3)
			{
				bus_dsp[i].pot_L[j] = 0.32 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.37 * bus[i].gen_MW;
			}
			if (j == 4)
			{
				bus_dsp[i].pot_L[j] = 0.33 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.39 * bus[i].gen_MW;
			}
			if (j == 5)
			{
				bus_dsp[i].pot_L[j] = 0.45 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.55 * bus[i].gen_MW;
			}
			if (j == 6)
			{
				bus_dsp[i].pot_L[j] = 0.57 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.65 * bus[i].gen_MW;
			}
			if (j == 7)
			{
				bus_dsp[i].pot_L[j] = 0.60 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.67 * bus[i].gen_MW;
			}
			if (j == 8)
			{
				bus_dsp[i].pot_L[j] = 0.63 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.68 * bus[i].gen_MW;
			}
			if (j == 9)
			{
				bus_dsp[i].pot_L[j] = 0.64 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.68 * bus[i].gen_MW;
			}
			if (j == 10)
			{
				bus_dsp[i].pot_L[j] = 0.68 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.70 * bus[i].gen_MW;
			}
			if (j == 11)
			{
				bus_dsp[i].pot_L[j] = 0.66 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.70 * bus[i].gen_MW;
			}
			if (j == 12)
			{
				bus_dsp[i].pot_L[j] = 0.73 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.75 * bus[i].gen_MW;
			}
			if (j == 13)
			{
				bus_dsp[i].pot_L[j] = 0.75 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.77 * bus[i].gen_MW;
			}
			if (j == 14)
			{
				bus_dsp[i].pot_L[j] = 0.72 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.74 * bus[i].gen_MW;
			}
			if (j == 15)
			{
				bus_dsp[i].pot_L[j] = 0.69 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.72 * bus[i].gen_MW;
			}
			if (j == 16)
			{
				bus_dsp[i].pot_L[j] = 0.65 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.7 * bus[i].gen_MW;
			}
			if (j == 17)
			{
				bus_dsp[i].pot_L[j] = 0.72 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.76 * bus[i].gen_MW;
			}
			if (j == 18)
			{
				bus_dsp[i].pot_L[j] = 0.77 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.79 * bus[i].gen_MW;
			}
			if (j == 19)
			{
				bus_dsp[i].pot_L[j] = 0.84 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.87 * bus[i].gen_MW;
			}
			if (j == 20)
			{
				bus_dsp[i].pot_L[j] = 0.89 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.91 * bus[i].gen_MW;
			}
			if (j == 21)
			{
				bus_dsp[i].pot_L[j] = 0.86 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.87 * bus[i].gen_MW;
			}
			if (j == 22)
			{
				bus_dsp[i].pot_L[j] = 0.75 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.82 * bus[i].gen_MW;
			}
			if (j == 23)
			{
				bus_dsp[i].pot_L[j] = 0.68 * bus[i].load_MW;
				bus_dsp[i].pot_G[j] = 0.73 * bus[i].gen_MW;
			}

		}
	}

	bus_dsp[9].pot_G[0] = 425.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 10
	bus_dsp[41].pot_G[0] = -18.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 42
	bus_dsp[88].pot_G[0] = 252.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 89

	bus_dsp[86].pot_G[5] = 0.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 87
	bus_dsp[88].pot_G[5] = 350.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 89
	bus_dsp[115].pot_G[5] = -70.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 116

	bus_dsp[33].pot_G[7] = 14.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 34
	bus_dsp[61].pot_G[7] = 20.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 62
	bus_dsp[98].pot_G[7] = -39.2;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 99

	bus_dsp[99].pot_G[12] = 200.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 100
	bus_dsp[104].pot_G[12] = 10.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 105

	bus_dsp[31].pot_G[13] = 34.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 32
	bus_dsp[76].pot_G[13] = 48.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 77

	bus_dsp[104].pot_G[18] = 15.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 105
	bus_dsp[103].pot_G[18] = 30.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 104
	bus_dsp[102].pot_G[18] = 5.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 103
	bus_dsp[99].pot_G[18] = 201.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 100

	//bus_dsp[48].pot_G[20] = 260.0; //MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 49
	bus_dsp[26].pot_G[20] = 2.1;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 27
	bus_dsp[35].pot_G[20] = 2.1;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 36
	bus_dsp[79].pot_G[20] = 485.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 80

	bus_dsp[30].pot_G[21] = -6.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 31
	bus_dsp[26].pot_G[21] = 1.6;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 27
	bus_dsp[15].pot_G[21] = -50.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 16
	bus_dsp[5].pot_G[21] = 65.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 6
	bus_dsp[99].pot_G[21] = 235.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 100

	bus_dsp[9].pot_G[22] = 540.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 10
	bus_dsp[5].pot_G[22] = 7.0;	//MUDANÇA DA POTÊNCIA DE GERAÇÃO DO BARRAMENTO 6

	int temp = horario;
	fprintf(stdout, "Simulating (x24)...\n");
	for (horario = 0; horario < 24; horario++)
		vpSimulator ();
	fprintf(stdout, "Simulation complete!\n");
	horario = temp;
}
